/* Autogenerated: /src/ExtractionOCaml/unsaturated_solinas --static p192 32 9 '2^192 - 2^64 - 1' add sub opp carry carry_mul carry_square carry_scmul3 carry_scmul4 carry_scmul8 selectznz to_bytes from_bytes */
/* curve description: p192 */
/* machine_wordsize = 32 (from "32") */
/* requested operations: add, sub, opp, carry, carry_mul, carry_square, carry_scmul3, carry_scmul4, carry_scmul8, selectznz, to_bytes, from_bytes */
/* n = 9 (from "9") */
/* s-c = 2^192 - [(2^64, 1), (1, 1)] (from "2^192 - 2^64 - 1") */
/* tight_bounds_multiplier = 1 (from "") */
/*  */
/* Computed values: */
/* carry_chain = [2, 8, 3, 0, 4, 1, 5, 2, 6, 7, 8, 3, 0] */
/* eval z = z[0] + (z[1] << 22) + (z[2] << 43) + (z[3] << 64) + (z[4] << 86) + (z[5] << 107) + (z[6] << 128) + (z[7] << 150) + (z[8] << 171) */
/* bytes_eval z = z[0] + (z[1] << 8) + (z[2] << 16) + (z[3] << 24) + (z[4] << 32) + (z[5] << 40) + (z[6] << 48) + (z[7] << 56) + (z[8] << 64) + (z[9] << 72) + (z[10] << 80) + (z[11] << 88) + (z[12] << 96) + (z[13] << 104) + (z[14] << 112) + (z[15] << 120) + (z[16] << 128) + (z[17] << 136) + (z[18] << 144) + (z[19] << 152) + (z[20] << 160) + (z[21] << 168) + (z[22] << 176) + (z[23] << 184) */
/* balance = [0x7ffffe, 0x3ffffe, 0x3ffffe, 0x7ffffc, 0x3ffffe, 0x3ffffe, 0x7ffffe, 0x3ffffe, 0x3ffffe] */

#include <stdint.h>
typedef unsigned char fiat_p192_uint1;
typedef signed char fiat_p192_int1;

#if (-1 & 3) != 3
#error "This code only works on a two's complement system"
#endif


/*
 * The function fiat_p192_addcarryx_u22 is an addition with carry.
 * Postconditions:
 *   out1 = (arg1 + arg2 + arg3) mod 2^22
 *   out2 = ⌊(arg1 + arg2 + arg3) / 2^22⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0x3fffff]
 *   arg3: [0x0 ~> 0x3fffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0x3fffff]
 *   out2: [0x0 ~> 0x1]
 */
static void fiat_p192_addcarryx_u22(uint32_t* out1, fiat_p192_uint1* out2, fiat_p192_uint1 arg1, uint32_t arg2, uint32_t arg3) {
  uint32_t x1;
  uint32_t x2;
  fiat_p192_uint1 x3;
  x1 = ((arg1 + arg2) + arg3);
  x2 = (x1 & UINT32_C(0x3fffff));
  x3 = (fiat_p192_uint1)(x1 >> 22);
  *out1 = x2;
  *out2 = x3;
}

/*
 * The function fiat_p192_subborrowx_u22 is a subtraction with borrow.
 * Postconditions:
 *   out1 = (-arg1 + arg2 + -arg3) mod 2^22
 *   out2 = -⌊(-arg1 + arg2 + -arg3) / 2^22⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0x3fffff]
 *   arg3: [0x0 ~> 0x3fffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0x3fffff]
 *   out2: [0x0 ~> 0x1]
 */
static void fiat_p192_subborrowx_u22(uint32_t* out1, fiat_p192_uint1* out2, fiat_p192_uint1 arg1, uint32_t arg2, uint32_t arg3) {
  int32_t x1;
  fiat_p192_int1 x2;
  uint32_t x3;
  x1 = ((int32_t)(arg2 - arg1) - (int32_t)arg3);
  x2 = (fiat_p192_int1)(x1 >> 22);
  x3 = (x1 & UINT32_C(0x3fffff));
  *out1 = x3;
  *out2 = (fiat_p192_uint1)(0x0 - x2);
}

/*
 * The function fiat_p192_addcarryx_u21 is an addition with carry.
 * Postconditions:
 *   out1 = (arg1 + arg2 + arg3) mod 2^21
 *   out2 = ⌊(arg1 + arg2 + arg3) / 2^21⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0x1fffff]
 *   arg3: [0x0 ~> 0x1fffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0x1fffff]
 *   out2: [0x0 ~> 0x1]
 */
static void fiat_p192_addcarryx_u21(uint32_t* out1, fiat_p192_uint1* out2, fiat_p192_uint1 arg1, uint32_t arg2, uint32_t arg3) {
  uint32_t x1;
  uint32_t x2;
  fiat_p192_uint1 x3;
  x1 = ((arg1 + arg2) + arg3);
  x2 = (x1 & UINT32_C(0x1fffff));
  x3 = (fiat_p192_uint1)(x1 >> 21);
  *out1 = x2;
  *out2 = x3;
}

/*
 * The function fiat_p192_subborrowx_u21 is a subtraction with borrow.
 * Postconditions:
 *   out1 = (-arg1 + arg2 + -arg3) mod 2^21
 *   out2 = -⌊(-arg1 + arg2 + -arg3) / 2^21⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0x1fffff]
 *   arg3: [0x0 ~> 0x1fffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0x1fffff]
 *   out2: [0x0 ~> 0x1]
 */
static void fiat_p192_subborrowx_u21(uint32_t* out1, fiat_p192_uint1* out2, fiat_p192_uint1 arg1, uint32_t arg2, uint32_t arg3) {
  int32_t x1;
  fiat_p192_int1 x2;
  uint32_t x3;
  x1 = ((int32_t)(arg2 - arg1) - (int32_t)arg3);
  x2 = (fiat_p192_int1)(x1 >> 21);
  x3 = (x1 & UINT32_C(0x1fffff));
  *out1 = x3;
  *out2 = (fiat_p192_uint1)(0x0 - x2);
}

/*
 * The function fiat_p192_cmovznz_u32 is a single-word conditional move.
 * Postconditions:
 *   out1 = (if arg1 = 0 then arg2 else arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffff]
 *   arg3: [0x0 ~> 0xffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffff]
 */
static void fiat_p192_cmovznz_u32(uint32_t* out1, fiat_p192_uint1 arg1, uint32_t arg2, uint32_t arg3) {
  fiat_p192_uint1 x1;
  uint32_t x2;
  uint32_t x3;
  x1 = (!(!arg1));
  x2 = ((fiat_p192_int1)(0x0 - x1) & UINT32_C(0xffffffff));
  x3 = ((fe_word_barrier(x2) & arg3) | (fe_word_barrier(~x2) & arg2));
  *out1 = x3;
}

/*
 * The function fiat_p192_add adds two field elements.
 * Postconditions:
 *   eval out1 mod m = (eval arg1 + eval arg2) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000]]
 *   arg2: [[0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000]]
 */
static void fiat_p192_add(uint32_t out1[9], const uint32_t arg1[9], const uint32_t arg2[9]) {
  uint32_t x1;
  uint32_t x2;
  uint32_t x3;
  uint32_t x4;
  uint32_t x5;
  uint32_t x6;
  uint32_t x7;
  uint32_t x8;
  uint32_t x9;
  x1 = ((arg1[0]) + (arg2[0]));
  x2 = ((arg1[1]) + (arg2[1]));
  x3 = ((arg1[2]) + (arg2[2]));
  x4 = ((arg1[3]) + (arg2[3]));
  x5 = ((arg1[4]) + (arg2[4]));
  x6 = ((arg1[5]) + (arg2[5]));
  x7 = ((arg1[6]) + (arg2[6]));
  x8 = ((arg1[7]) + (arg2[7]));
  x9 = ((arg1[8]) + (arg2[8]));
  out1[0] = x1;
  out1[1] = x2;
  out1[2] = x3;
  out1[3] = x4;
  out1[4] = x5;
  out1[5] = x6;
  out1[6] = x7;
  out1[7] = x8;
  out1[8] = x9;
}

/*
 * The function fiat_p192_sub subtracts two field elements.
 * Postconditions:
 *   eval out1 mod m = (eval arg1 - eval arg2) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000]]
 *   arg2: [[0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000]]
 */
static void fiat_p192_sub(uint32_t out1[9], const uint32_t arg1[9], const uint32_t arg2[9]) {
  uint32_t x1;
  uint32_t x2;
  uint32_t x3;
  uint32_t x4;
  uint32_t x5;
  uint32_t x6;
  uint32_t x7;
  uint32_t x8;
  uint32_t x9;
  x1 = ((UINT32_C(0x7ffffe) + (arg1[0])) - (arg2[0]));
  x2 = ((UINT32_C(0x3ffffe) + (arg1[1])) - (arg2[1]));
  x3 = ((UINT32_C(0x3ffffe) + (arg1[2])) - (arg2[2]));
  x4 = ((UINT32_C(0x7ffffc) + (arg1[3])) - (arg2[3]));
  x5 = ((UINT32_C(0x3ffffe) + (arg1[4])) - (arg2[4]));
  x6 = ((UINT32_C(0x3ffffe) + (arg1[5])) - (arg2[5]));
  x7 = ((UINT32_C(0x7ffffe) + (arg1[6])) - (arg2[6]));
  x8 = ((UINT32_C(0x3ffffe) + (arg1[7])) - (arg2[7]));
  x9 = ((UINT32_C(0x3ffffe) + (arg1[8])) - (arg2[8]));
  out1[0] = x1;
  out1[1] = x2;
  out1[2] = x3;
  out1[3] = x4;
  out1[4] = x5;
  out1[5] = x6;
  out1[6] = x7;
  out1[7] = x8;
  out1[8] = x9;
}

/*
 * The function fiat_p192_opp negates a field element.
 * Postconditions:
 *   eval out1 mod m = -eval arg1 mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000]]
 */
static void fiat_p192_opp(uint32_t out1[9], const uint32_t arg1[9]) {
  uint32_t x1;
  uint32_t x2;
  uint32_t x3;
  uint32_t x4;
  uint32_t x5;
  uint32_t x6;
  uint32_t x7;
  uint32_t x8;
  uint32_t x9;
  x1 = (UINT32_C(0x7ffffe) - (arg1[0]));
  x2 = (UINT32_C(0x3ffffe) - (arg1[1]));
  x3 = (UINT32_C(0x3ffffe) - (arg1[2]));
  x4 = (UINT32_C(0x7ffffc) - (arg1[3]));
  x5 = (UINT32_C(0x3ffffe) - (arg1[4]));
  x6 = (UINT32_C(0x3ffffe) - (arg1[5]));
  x7 = (UINT32_C(0x7ffffe) - (arg1[6]));
  x8 = (UINT32_C(0x3ffffe) - (arg1[7]));
  x9 = (UINT32_C(0x3ffffe) - (arg1[8]));
  out1[0] = x1;
  out1[1] = x2;
  out1[2] = x3;
  out1[3] = x4;
  out1[4] = x5;
  out1[5] = x6;
  out1[6] = x7;
  out1[7] = x8;
  out1[8] = x9;
}

/*
 * The function fiat_p192_carry reduces a field element.
 * Postconditions:
 *   eval out1 mod m = eval arg1 mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000]]
 */
static void fiat_p192_carry(uint32_t out1[9], const uint32_t arg1[9]) {
  uint32_t x1;
  uint32_t x2;
  uint32_t x3;
  uint32_t x4;
  uint32_t x5;
  uint32_t x6;
  uint32_t x7;
  uint32_t x8;
  uint32_t x9;
  uint32_t x10;
  uint32_t x11;
  uint32_t x12;
  fiat_p192_uint1 x13;
  uint32_t x14;
  uint32_t x15;
  uint32_t x16;
  uint32_t x17;
  uint32_t x18;
  uint32_t x19;
  uint32_t x20;
  uint32_t x21;
  uint32_t x22;
  uint32_t x23;
  uint32_t x24;
  x1 = (arg1[2]);
  x2 = (arg1[8]);
  x3 = (x2 >> 21);
  x4 = (((x1 >> 21) + (arg1[3])) + x3);
  x5 = ((arg1[0]) + x3);
  x6 = ((x4 >> 22) + (arg1[4]));
  x7 = ((x5 >> 22) + (arg1[1]));
  x8 = ((x6 >> 21) + (arg1[5]));
  x9 = ((x7 >> 21) + (x1 & UINT32_C(0x1fffff)));
  x10 = ((x8 >> 21) + (arg1[6]));
  x11 = ((x10 >> 22) + (arg1[7]));
  x12 = ((x11 >> 21) + (x2 & UINT32_C(0x1fffff)));
  x13 = (fiat_p192_uint1)(x12 >> 21);
  x14 = (((fiat_p192_uint1)(x9 >> 21) + (x4 & UINT32_C(0x3fffff))) + (uint32_t)x13);
  x15 = ((x5 & UINT32_C(0x3fffff)) + (uint32_t)x13);
  x16 = (x15 & UINT32_C(0x3fffff));
  x17 = ((fiat_p192_uint1)(x15 >> 22) + (x7 & UINT32_C(0x1fffff)));
  x18 = (x9 & UINT32_C(0x1fffff));
  x19 = (x14 & UINT32_C(0x3fffff));
  x20 = ((fiat_p192_uint1)(x14 >> 22) + (x6 & UINT32_C(0x1fffff)));
  x21 = (x8 & UINT32_C(0x1fffff));
  x22 = (x10 & UINT32_C(0x3fffff));
  x23 = (x11 & UINT32_C(0x1fffff));
  x24 = (x12 & UINT32_C(0x1fffff));
  out1[0] = x16;
  out1[1] = x17;
  out1[2] = x18;
  out1[3] = x19;
  out1[4] = x20;
  out1[5] = x21;
  out1[6] = x22;
  out1[7] = x23;
  out1[8] = x24;
}

/*
 * The function fiat_p192_carry_mul multiplies two field elements and reduces the result.
 * Postconditions:
 *   eval out1 mod m = (eval arg1 * eval arg2) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000]]
 *   arg2: [[0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000]]
 */
static void fiat_p192_carry_mul(uint32_t out1[9], const uint32_t arg1[9], const uint32_t arg2[9]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  uint64_t x9;
  uint64_t x10;
  uint64_t x11;
  uint64_t x12;
  uint64_t x13;
  uint64_t x14;
  uint64_t x15;
  uint64_t x16;
  uint64_t x17;
  uint64_t x18;
  uint64_t x19;
  uint64_t x20;
  uint64_t x21;
  uint64_t x22;
  uint64_t x23;
  uint64_t x24;
  uint64_t x25;
  uint64_t x26;
  uint64_t x27;
  uint64_t x28;
  uint64_t x29;
  uint64_t x30;
  uint64_t x31;
  uint64_t x32;
  uint64_t x33;
  uint64_t x34;
  uint64_t x35;
  uint64_t x36;
  uint64_t x37;
  uint64_t x38;
  uint64_t x39;
  uint64_t x40;
  uint64_t x41;
  uint64_t x42;
  uint64_t x43;
  uint64_t x44;
  uint64_t x45;
  uint64_t x46;
  uint64_t x47;
  uint64_t x48;
  uint64_t x49;
  uint64_t x50;
  uint64_t x51;
  uint64_t x52;
  uint64_t x53;
  uint64_t x54;
  uint64_t x55;
  uint64_t x56;
  uint64_t x57;
  uint64_t x58;
  uint64_t x59;
  uint64_t x60;
  uint64_t x61;
  uint64_t x62;
  uint64_t x63;
  uint64_t x64;
  uint64_t x65;
  uint64_t x66;
  uint64_t x67;
  uint64_t x68;
  uint64_t x69;
  uint64_t x70;
  uint64_t x71;
  uint64_t x72;
  uint64_t x73;
  uint64_t x74;
  uint64_t x75;
  uint64_t x76;
  uint64_t x77;
  uint64_t x78;
  uint64_t x79;
  uint64_t x80;
  uint64_t x81;
  uint64_t x82;
  uint64_t x83;
  uint64_t x84;
  uint64_t x85;
  uint64_t x86;
  uint64_t x87;
  uint64_t x88;
  uint64_t x89;
  uint64_t x90;
  uint64_t x91;
  uint64_t x92;
  uint64_t x93;
  uint64_t x94;
  uint64_t x95;
  uint64_t x96;
  uint64_t x97;
  uint64_t x98;
  uint64_t x99;
  uint64_t x100;
  uint64_t x101;
  uint64_t x102;
  uint64_t x103;
  uint64_t x104;
  uint64_t x105;
  uint64_t x106;
  uint64_t x107;
  uint64_t x108;
  uint64_t x109;
  uint64_t x110;
  uint64_t x111;
  uint64_t x112;
  uint64_t x113;
  uint64_t x114;
  uint64_t x115;
  uint64_t x116;
  uint64_t x117;
  uint64_t x118;
  uint64_t x119;
  uint64_t x120;
  uint64_t x121;
  uint32_t x122;
  uint32_t x123;
  uint64_t x124;
  uint64_t x125;
  uint64_t x126;
  uint64_t x127;
  uint64_t x128;
  uint64_t x129;
  uint64_t x130;
  uint64_t x131;
  uint64_t x132;
  uint32_t x133;
  uint32_t x134;
  uint64_t x135;
  uint32_t x136;
  uint32_t x137;
  uint64_t x138;
  uint64_t x139;
  uint32_t x140;
  uint32_t x141;
  uint64_t x142;
  uint32_t x143;
  uint32_t x144;
  uint64_t x145;
  uint32_t x146;
  uint32_t x147;
  uint32_t x148;
  uint32_t x149;
  uint32_t x150;
  uint64_t x151;
  uint32_t x152;
  uint32_t x153;
  uint32_t x154;
  uint32_t x155;
  uint32_t x156;
  uint64_t x157;
  uint32_t x158;
  uint32_t x159;
  uint32_t x160;
  uint32_t x161;
  uint32_t x162;
  uint32_t x163;
  fiat_p192_uint1 x164;
  uint32_t x165;
  uint32_t x166;
  uint32_t x167;
  fiat_p192_uint1 x168;
  uint32_t x169;
  uint32_t x170;
  x1 = ((uint64_t)(arg1[8]) * (arg2[8]));
  x2 = ((uint64_t)(arg1[8]) * ((arg2[7]) * 0x2));
  x3 = ((uint64_t)(arg1[7]) * ((arg2[8]) * 0x2));
  x4 = ((uint64_t)(arg1[8]) * (arg2[8]));
  x5 = ((uint64_t)(arg1[8]) * ((arg2[7]) * 0x2));
  x6 = ((uint64_t)(arg1[7]) * ((arg2[8]) * 0x2));
  x7 = ((uint64_t)(arg1[8]) * (arg2[8]));
  x8 = ((uint64_t)(arg1[8]) * ((arg2[7]) * 0x2));
  x9 = ((uint64_t)(arg1[8]) * (arg2[6]));
  x10 = ((uint64_t)(arg1[8]) * (arg2[5]));
  x11 = ((uint64_t)(arg1[8]) * ((arg2[4]) * 0x2));
  x12 = ((uint64_t)(arg1[8]) * (arg2[3]));
  x13 = ((uint64_t)(arg1[8]) * (arg2[2]));
  x14 = ((uint64_t)(arg1[8]) * ((arg2[1]) * 0x2));
  x15 = ((uint64_t)(arg1[7]) * ((arg2[8]) * 0x2));
  x16 = ((uint64_t)(arg1[7]) * ((arg2[7]) * 0x2));
  x17 = ((uint64_t)(arg1[7]) * (arg2[6]));
  x18 = ((uint64_t)(arg1[7]) * ((arg2[5]) * 0x2));
  x19 = ((uint64_t)(arg1[7]) * ((arg2[4]) * 0x2));
  x20 = ((uint64_t)(arg1[7]) * (arg2[3]));
  x21 = ((uint64_t)(arg1[7]) * ((arg2[2]) * 0x2));
  x22 = ((uint64_t)(arg1[6]) * (arg2[8]));
  x23 = ((uint64_t)(arg1[6]) * (arg2[7]));
  x24 = ((uint64_t)(arg1[6]) * (arg2[6]));
  x25 = ((uint64_t)(arg1[6]) * (arg2[5]));
  x26 = ((uint64_t)(arg1[6]) * (arg2[4]));
  x27 = ((uint64_t)(arg1[6]) * (arg2[3]));
  x28 = ((uint64_t)(arg1[5]) * (arg2[8]));
  x29 = ((uint64_t)(arg1[5]) * ((arg2[7]) * 0x2));
  x30 = ((uint64_t)(arg1[5]) * (arg2[6]));
  x31 = ((uint64_t)(arg1[5]) * (arg2[5]));
  x32 = ((uint64_t)(arg1[5]) * ((arg2[4]) * 0x2));
  x33 = ((uint64_t)(arg1[4]) * ((arg2[8]) * 0x2));
  x34 = ((uint64_t)(arg1[4]) * ((arg2[7]) * 0x2));
  x35 = ((uint64_t)(arg1[4]) * (arg2[6]));
  x36 = ((uint64_t)(arg1[4]) * ((arg2[5]) * 0x2));
  x37 = ((uint64_t)(arg1[3]) * (arg2[8]));
  x38 = ((uint64_t)(arg1[3]) * (arg2[7]));
  x39 = ((uint64_t)(arg1[3]) * (arg2[6]));
  x40 = ((uint64_t)(arg1[2]) * (arg2[8]));
  x41 = ((uint64_t)(arg1[2]) * ((arg2[7]) * 0x2));
  x42 = ((uint64_t)(arg1[1]) * ((arg2[8]) * 0x2));
  x43 = ((uint64_t)(arg1[8]) * (arg2[6]));
  x44 = ((uint64_t)(arg1[8]) * (arg2[5]));
  x45 = ((uint64_t)(arg1[8]) * ((arg2[4]) * 0x2));
  x46 = ((uint64_t)(arg1[8]) * (arg2[3]));
  x47 = ((uint64_t)(arg1[8]) * (arg2[2]));
  x48 = ((uint64_t)(arg1[8]) * ((arg2[1]) * 0x2));
  x49 = ((uint64_t)(arg1[7]) * ((arg2[7]) * 0x2));
  x50 = ((uint64_t)(arg1[7]) * (arg2[6]));
  x51 = ((uint64_t)(arg1[7]) * ((arg2[5]) * 0x2));
  x52 = ((uint64_t)(arg1[7]) * ((arg2[4]) * 0x2));
  x53 = ((uint64_t)(arg1[7]) * (arg2[3]));
  x54 = ((uint64_t)(arg1[7]) * ((arg2[2]) * 0x2));
  x55 = ((uint64_t)(arg1[6]) * (arg2[8]));
  x56 = ((uint64_t)(arg1[6]) * (arg2[7]));
  x57 = ((uint64_t)(arg1[6]) * (arg2[6]));
  x58 = ((uint64_t)(arg1[6]) * (arg2[5]));
  x59 = ((uint64_t)(arg1[6]) * (arg2[4]));
  x60 = ((uint64_t)(arg1[6]) * (arg2[3]));
  x61 = ((uint64_t)(arg1[5]) * (arg2[8]));
  x62 = ((uint64_t)(arg1[5]) * ((arg2[7]) * 0x2));
  x63 = ((uint64_t)(arg1[5]) * (arg2[6]));
  x64 = ((uint64_t)(arg1[5]) * (arg2[5]));
  x65 = ((uint64_t)(arg1[5]) * ((arg2[4]) * 0x2));
  x66 = ((uint64_t)(arg1[4]) * ((arg2[8]) * 0x2));
  x67 = ((uint64_t)(arg1[4]) * ((arg2[7]) * 0x2));
  x68 = ((uint64_t)(arg1[4]) * (arg2[6]));
  x69 = ((uint64_t)(arg1[4]) * ((arg2[5]) * 0x2));
  x70 = ((uint64_t)(arg1[3]) * (arg2[8]));
  x71 = ((uint64_t)(arg1[3]) * (arg2[7]));
  x72 = ((uint64_t)(arg1[3]) * (arg2[6]));
  x73 = ((uint64_t)(arg1[2]) * (arg2[8]));
  x74 = ((uint64_t)(arg1[2]) * ((arg2[7]) * 0x2));
  x75 = ((uint64_t)(arg1[1]) * ((arg2[8]) * 0x2));
  x76 = ((uint64_t)(arg1[8]) * (arg2[0]));
  x77 = ((uint64_t)(arg1[7]) * ((arg2[1]) * 0x2));
  x78 = ((uint64_t)(arg1[7]) * (arg2[0]));
  x79 = ((uint64_t)(arg1[6]) * (arg2[2]));
  x80 = ((uint64_t)(arg1[6]) * (arg2[1]));
  x81 = ((uint64_t)(arg1[6]) * (arg2[0]));
  x82 = ((uint64_t)(arg1[5]) * (arg2[3]));
  x83 = ((uint64_t)(arg1[5]) * (arg2[2]));
  x84 = ((uint64_t)(arg1[5]) * ((arg2[1]) * 0x2));
  x85 = ((uint64_t)(arg1[5]) * (arg2[0]));
  x86 = ((uint64_t)(arg1[4]) * ((arg2[4]) * 0x2));
  x87 = ((uint64_t)(arg1[4]) * (arg2[3]));
  x88 = ((uint64_t)(arg1[4]) * ((arg2[2]) * 0x2));
  x89 = ((uint64_t)(arg1[4]) * ((arg2[1]) * 0x2));
  x90 = ((uint64_t)(arg1[4]) * (arg2[0]));
  x91 = ((uint64_t)(arg1[3]) * (arg2[5]));
  x92 = ((uint64_t)(arg1[3]) * (arg2[4]));
  x93 = ((uint64_t)(arg1[3]) * (arg2[3]));
  x94 = ((uint64_t)(arg1[3]) * (arg2[2]));
  x95 = ((uint64_t)(arg1[3]) * (arg2[1]));
  x96 = ((uint64_t)(arg1[3]) * (arg2[0]));
  x97 = ((uint64_t)(arg1[2]) * (arg2[6]));
  x98 = ((uint64_t)(arg1[2]) * (arg2[5]));
  x99 = ((uint64_t)(arg1[2]) * ((arg2[4]) * 0x2));
  x100 = ((uint64_t)(arg1[2]) * (arg2[3]));
  x101 = ((uint64_t)(arg1[2]) * (arg2[2]));
  x102 = ((uint64_t)(arg1[2]) * ((arg2[1]) * 0x2));
  x103 = ((uint64_t)(arg1[2]) * (arg2[0]));
  x104 = ((uint64_t)(arg1[1]) * ((arg2[7]) * 0x2));
  x105 = ((uint64_t)(arg1[1]) * (arg2[6]));
  x106 = ((uint64_t)(arg1[1]) * ((arg2[5]) * 0x2));
  x107 = ((uint64_t)(arg1[1]) * ((arg2[4]) * 0x2));
  x108 = ((uint64_t)(arg1[1]) * (arg2[3]));
  x109 = ((uint64_t)(arg1[1]) * ((arg2[2]) * 0x2));
  x110 = ((uint64_t)(arg1[1]) * ((arg2[1]) * 0x2));
  x111 = ((uint64_t)(arg1[1]) * (arg2[0]));
  x112 = ((uint64_t)(arg1[0]) * (arg2[8]));
  x113 = ((uint64_t)(arg1[0]) * (arg2[7]));
  x114 = ((uint64_t)(arg1[0]) * (arg2[6]));
  x115 = ((uint64_t)(arg1[0]) * (arg2[5]));
  x116 = ((uint64_t)(arg1[0]) * (arg2[4]));
  x117 = ((uint64_t)(arg1[0]) * (arg2[3]));
  x118 = ((uint64_t)(arg1[0]) * (arg2[2]));
  x119 = ((uint64_t)(arg1[0]) * (arg2[1]));
  x120 = ((uint64_t)(arg1[0]) * (arg2[0]));
  x121 = (x118 + (x110 + (x103 + (x37 + (x34 + (x30 + (x25 + (x19 + x12))))))));
  x122 = (uint32_t)(x121 >> 21);
  x123 = (uint32_t)(x121 & UINT32_C(0x1fffff));
  x124 = (x112 + (x104 + (x97 + (x91 + (x86 + (x82 + (x79 + (x77 + (x76 + (x55 + (x49 + x43)))))))))));
  x125 = (x113 + (x105 + (x98 + (x92 + (x87 + (x83 + (x80 + (x78 + (x61 + (x56 + (x50 + (x44 + x7))))))))))));
  x126 = (x114 + (x106 + (x99 + (x93 + (x88 + (x84 + (x81 + (x66 + (x62 + (x57 + (x51 + (x45 + (x15 + x8)))))))))))));
  x127 = (x115 + (x107 + (x100 + (x94 + (x89 + (x85 + (x70 + (x67 + (x63 + (x58 + (x52 + (x46 + (x22 + (x16 + x9))))))))))))));
  x128 = (x116 + (x108 + (x101 + (x95 + (x90 + (x73 + (x71 + (x68 + (x64 + (x59 + (x53 + (x47 + (x28 + (x23 + (x17 + (x10 + x4))))))))))))))));
  x129 = (x117 + (x109 + (x102 + (x96 + (x75 + (x74 + (x72 + (x69 + (x65 + (x60 + (x54 + (x48 + (x33 + (x29 + (x24 + (x18 + (x11 + (x6 + x5))))))))))))))))));
  x130 = (x119 + (x111 + (x40 + (x38 + (x35 + (x31 + (x26 + (x20 + (x13 + x1)))))))));
  x131 = (x120 + (x42 + (x41 + (x39 + (x36 + (x32 + (x27 + (x21 + (x14 + (x3 + x2))))))))));
  x132 = (x122 + x129);
  x133 = (uint32_t)(x124 >> 21);
  x134 = (uint32_t)(x124 & UINT32_C(0x1fffff));
  x135 = (x132 + x133);
  x136 = (uint32_t)(x135 >> 22);
  x137 = (uint32_t)(x135 & UINT32_C(0x3fffff));
  x138 = (x131 + x133);
  x139 = (x136 + x128);
  x140 = (uint32_t)(x138 >> 22);
  x141 = (uint32_t)(x138 & UINT32_C(0x3fffff));
  x142 = (x140 + x130);
  x143 = (uint32_t)(x139 >> 21);
  x144 = (uint32_t)(x139 & UINT32_C(0x1fffff));
  x145 = (x143 + x127);
  x146 = (uint32_t)(x142 >> 21);
  x147 = (uint32_t)(x142 & UINT32_C(0x1fffff));
  x148 = (x146 + x123);
  x149 = (uint32_t)(x145 >> 21);
  x150 = (uint32_t)(x145 & UINT32_C(0x1fffff));
  x151 = (x149 + x126);
  x152 = (x148 >> 21);
  x153 = (x148 & UINT32_C(0x1fffff));
  x154 = (x152 + x137);
  x155 = (uint32_t)(x151 >> 22);
  x156 = (uint32_t)(x151 & UINT32_C(0x3fffff));
  x157 = (x155 + x125);
  x158 = (uint32_t)(x157 >> 21);
  x159 = (uint32_t)(x157 & UINT32_C(0x1fffff));
  x160 = (x158 + x134);
  x161 = (x160 >> 21);
  x162 = (x160 & UINT32_C(0x1fffff));
  x163 = (x154 + x161);
  x164 = (fiat_p192_uint1)(x163 >> 22);
  x165 = (x163 & UINT32_C(0x3fffff));
  x166 = (x141 + x161);
  x167 = (x164 + x144);
  x168 = (fiat_p192_uint1)(x166 >> 22);
  x169 = (x166 & UINT32_C(0x3fffff));
  x170 = (x168 + x147);
  out1[0] = x169;
  out1[1] = x170;
  out1[2] = x153;
  out1[3] = x165;
  out1[4] = x167;
  out1[5] = x150;
  out1[6] = x156;
  out1[7] = x159;
  out1[8] = x162;
}

/*
 * The function fiat_p192_carry_square squares a field element and reduces the result.
 * Postconditions:
 *   eval out1 mod m = (eval arg1 * eval arg1) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000]]
 */
static void fiat_p192_carry_square(uint32_t out1[9], const uint32_t arg1[9]) {
  uint32_t x1;
  uint32_t x2;
  uint32_t x3;
  uint32_t x4;
  uint32_t x5;
  uint32_t x6;
  uint32_t x7;
  uint32_t x8;
  uint32_t x9;
  uint32_t x10;
  uint32_t x11;
  uint32_t x12;
  uint32_t x13;
  uint32_t x14;
  uint32_t x15;
  uint32_t x16;
  uint32_t x17;
  uint32_t x18;
  uint32_t x19;
  uint32_t x20;
  uint32_t x21;
  uint32_t x22;
  uint32_t x23;
  uint32_t x24;
  uint64_t x25;
  uint64_t x26;
  uint64_t x27;
  uint64_t x28;
  uint64_t x29;
  uint64_t x30;
  uint64_t x31;
  uint64_t x32;
  uint64_t x33;
  uint64_t x34;
  uint64_t x35;
  uint64_t x36;
  uint64_t x37;
  uint64_t x38;
  uint64_t x39;
  uint64_t x40;
  uint64_t x41;
  uint64_t x42;
  uint64_t x43;
  uint64_t x44;
  uint64_t x45;
  uint64_t x46;
  uint64_t x47;
  uint64_t x48;
  uint64_t x49;
  uint64_t x50;
  uint64_t x51;
  uint64_t x52;
  uint64_t x53;
  uint64_t x54;
  uint64_t x55;
  uint64_t x56;
  uint64_t x57;
  uint64_t x58;
  uint64_t x59;
  uint64_t x60;
  uint64_t x61;
  uint64_t x62;
  uint64_t x63;
  uint64_t x64;
  uint64_t x65;
  uint64_t x66;
  uint64_t x67;
  uint64_t x68;
  uint64_t x69;
  uint64_t x70;
  uint64_t x71;
  uint64_t x72;
  uint64_t x73;
  uint64_t x74;
  uint64_t x75;
  uint64_t x76;
  uint64_t x77;
  uint64_t x78;
  uint64_t x79;
  uint64_t x80;
  uint64_t x81;
  uint64_t x82;
  uint64_t x83;
  uint64_t x84;
  uint64_t x85;
  uint64_t x86;
  uint64_t x87;
  uint64_t x88;
  uint64_t x89;
  uint64_t x90;
  uint64_t x91;
  uint64_t x92;
  uint32_t x93;
  uint32_t x94;
  uint64_t x95;
  uint64_t x96;
  uint64_t x97;
  uint64_t x98;
  uint64_t x99;
  uint64_t x100;
  uint64_t x101;
  uint64_t x102;
  uint64_t x103;
  uint32_t x104;
  uint32_t x105;
  uint64_t x106;
  uint32_t x107;
  uint32_t x108;
  uint64_t x109;
  uint64_t x110;
  uint32_t x111;
  uint32_t x112;
  uint64_t x113;
  uint32_t x114;
  uint32_t x115;
  uint64_t x116;
  uint32_t x117;
  uint32_t x118;
  uint32_t x119;
  uint32_t x120;
  uint32_t x121;
  uint64_t x122;
  uint32_t x123;
  uint32_t x124;
  uint32_t x125;
  uint32_t x126;
  uint32_t x127;
  uint64_t x128;
  uint32_t x129;
  uint32_t x130;
  uint32_t x131;
  uint32_t x132;
  uint32_t x133;
  uint32_t x134;
  fiat_p192_uint1 x135;
  uint32_t x136;
  uint32_t x137;
  uint32_t x138;
  fiat_p192_uint1 x139;
  uint32_t x140;
  uint32_t x141;
  x1 = (arg1[8]);
  x2 = (arg1[8]);
  x3 = (x1 * 0x2);
  x4 = (x2 * 0x2);
  x5 = ((arg1[8]) * 0x2);
  x6 = (arg1[7]);
  x7 = (arg1[7]);
  x8 = (x6 * 0x2);
  x9 = (x7 * 0x2);
  x10 = ((arg1[7]) * 0x2);
  x11 = (arg1[6]);
  x12 = (arg1[6]);
  x13 = (x11 * 0x2);
  x14 = (x12 * 0x2);
  x15 = ((arg1[6]) * 0x2);
  x16 = (arg1[5]);
  x17 = (arg1[5]);
  x18 = (x16 * 0x2);
  x19 = (x17 * 0x2);
  x20 = ((arg1[5]) * 0x2);
  x21 = ((arg1[4]) * 0x2);
  x22 = ((arg1[3]) * 0x2);
  x23 = ((arg1[2]) * 0x2);
  x24 = ((arg1[1]) * 0x2);
  x25 = ((uint64_t)(arg1[8]) * x1);
  x26 = ((uint64_t)(arg1[7]) * (x3 * 0x2));
  x27 = ((uint64_t)(arg1[8]) * x1);
  x28 = ((uint64_t)(arg1[7]) * (x3 * 0x2));
  x29 = ((uint64_t)(arg1[8]) * x2);
  x30 = ((uint64_t)(arg1[7]) * (x4 * 0x2));
  x31 = ((uint64_t)(arg1[7]) * (x7 * 0x2));
  x32 = ((uint64_t)(arg1[7]) * (x6 * 0x2));
  x33 = ((uint64_t)(arg1[6]) * x4);
  x34 = ((uint64_t)(arg1[6]) * x3);
  x35 = ((uint64_t)(arg1[6]) * x9);
  x36 = ((uint64_t)(arg1[6]) * x8);
  x37 = ((uint64_t)(arg1[6]) * x12);
  x38 = ((uint64_t)(arg1[6]) * x11);
  x39 = ((uint64_t)(arg1[5]) * x4);
  x40 = ((uint64_t)(arg1[5]) * x3);
  x41 = ((uint64_t)(arg1[5]) * (x9 * 0x2));
  x42 = ((uint64_t)(arg1[5]) * (x8 * 0x2));
  x43 = ((uint64_t)(arg1[5]) * x14);
  x44 = ((uint64_t)(arg1[5]) * x13);
  x45 = ((uint64_t)(arg1[5]) * x17);
  x46 = ((uint64_t)(arg1[5]) * x16);
  x47 = ((uint64_t)(arg1[4]) * (x4 * 0x2));
  x48 = ((uint64_t)(arg1[4]) * (x3 * 0x2));
  x49 = ((uint64_t)(arg1[4]) * (x9 * 0x2));
  x50 = ((uint64_t)(arg1[4]) * (x8 * 0x2));
  x51 = ((uint64_t)(arg1[4]) * x14);
  x52 = ((uint64_t)(arg1[4]) * x13);
  x53 = ((uint64_t)(arg1[4]) * (x19 * 0x2));
  x54 = ((uint64_t)(arg1[4]) * (x18 * 0x2));
  x55 = ((uint64_t)(arg1[4]) * ((arg1[4]) * 0x2));
  x56 = ((uint64_t)(arg1[3]) * x4);
  x57 = ((uint64_t)(arg1[3]) * x3);
  x58 = ((uint64_t)(arg1[3]) * x9);
  x59 = ((uint64_t)(arg1[3]) * x8);
  x60 = ((uint64_t)(arg1[3]) * x14);
  x61 = ((uint64_t)(arg1[3]) * x13);
  x62 = ((uint64_t)(arg1[3]) * x20);
  x63 = ((uint64_t)(arg1[3]) * x21);
  x64 = ((uint64_t)(arg1[3]) * (arg1[3]));
  x65 = ((uint64_t)(arg1[2]) * x4);
  x66 = ((uint64_t)(arg1[2]) * x3);
  x67 = ((uint64_t)(arg1[2]) * (x9 * 0x2));
  x68 = ((uint64_t)(arg1[2]) * (x8 * 0x2));
  x69 = ((uint64_t)(arg1[2]) * x15);
  x70 = ((uint64_t)(arg1[2]) * x20);
  x71 = ((uint64_t)(arg1[2]) * (x21 * 0x2));
  x72 = ((uint64_t)(arg1[2]) * x22);
  x73 = ((uint64_t)(arg1[2]) * (arg1[2]));
  x74 = ((uint64_t)(arg1[1]) * (x4 * 0x2));
  x75 = ((uint64_t)(arg1[1]) * (x3 * 0x2));
  x76 = ((uint64_t)(arg1[1]) * (x10 * 0x2));
  x77 = ((uint64_t)(arg1[1]) * x15);
  x78 = ((uint64_t)(arg1[1]) * (x20 * 0x2));
  x79 = ((uint64_t)(arg1[1]) * (x21 * 0x2));
  x80 = ((uint64_t)(arg1[1]) * x22);
  x81 = ((uint64_t)(arg1[1]) * (x23 * 0x2));
  x82 = ((uint64_t)(arg1[1]) * ((arg1[1]) * 0x2));
  x83 = ((uint64_t)(arg1[0]) * x5);
  x84 = ((uint64_t)(arg1[0]) * x10);
  x85 = ((uint64_t)(arg1[0]) * x15);
  x86 = ((uint64_t)(arg1[0]) * x20);
  x87 = ((uint64_t)(arg1[0]) * x21);
  x88 = ((uint64_t)(arg1[0]) * x22);
  x89 = ((uint64_t)(arg1[0]) * x23);
  x90 = ((uint64_t)(arg1[0]) * x24);
  x91 = ((uint64_t)(arg1[0]) * (arg1[0]));
  x92 = (x89 + (x82 + (x56 + (x49 + x43))));
  x93 = (uint32_t)(x92 >> 21);
  x94 = (uint32_t)(x92 & UINT32_C(0x1fffff));
  x95 = (x83 + (x76 + (x69 + (x62 + (x55 + (x34 + x32))))));
  x96 = (x84 + (x77 + (x70 + (x63 + (x40 + (x36 + x29))))));
  x97 = (x85 + (x78 + (x71 + (x64 + (x48 + (x42 + (x38 + x30)))))));
  x98 = (x86 + (x79 + (x72 + (x57 + (x50 + (x44 + (x33 + x31)))))));
  x99 = (x87 + (x80 + (x73 + (x66 + (x59 + (x52 + (x46 + (x39 + (x35 + x27)))))))));
  x100 = (x88 + (x81 + (x75 + (x68 + (x61 + (x54 + (x47 + (x41 + (x37 + x28)))))))));
  x101 = (x90 + (x65 + (x58 + (x51 + (x45 + x25)))));
  x102 = (x91 + (x74 + (x67 + (x60 + (x53 + x26)))));
  x103 = (x93 + x100);
  x104 = (uint32_t)(x95 >> 21);
  x105 = (uint32_t)(x95 & UINT32_C(0x1fffff));
  x106 = (x103 + x104);
  x107 = (uint32_t)(x106 >> 22);
  x108 = (uint32_t)(x106 & UINT32_C(0x3fffff));
  x109 = (x102 + x104);
  x110 = (x107 + x99);
  x111 = (uint32_t)(x109 >> 22);
  x112 = (uint32_t)(x109 & UINT32_C(0x3fffff));
  x113 = (x111 + x101);
  x114 = (uint32_t)(x110 >> 21);
  x115 = (uint32_t)(x110 & UINT32_C(0x1fffff));
  x116 = (x114 + x98);
  x117 = (uint32_t)(x113 >> 21);
  x118 = (uint32_t)(x113 & UINT32_C(0x1fffff));
  x119 = (x117 + x94);
  x120 = (uint32_t)(x116 >> 21);
  x121 = (uint32_t)(x116 & UINT32_C(0x1fffff));
  x122 = (x120 + x97);
  x123 = (x119 >> 21);
  x124 = (x119 & UINT32_C(0x1fffff));
  x125 = (x123 + x108);
  x126 = (uint32_t)(x122 >> 22);
  x127 = (uint32_t)(x122 & UINT32_C(0x3fffff));
  x128 = (x126 + x96);
  x129 = (uint32_t)(x128 >> 21);
  x130 = (uint32_t)(x128 & UINT32_C(0x1fffff));
  x131 = (x129 + x105);
  x132 = (x131 >> 21);
  x133 = (x131 & UINT32_C(0x1fffff));
  x134 = (x125 + x132);
  x135 = (fiat_p192_uint1)(x134 >> 22);
  x136 = (x134 & UINT32_C(0x3fffff));
  x137 = (x112 + x132);
  x138 = (x135 + x115);
  x139 = (fiat_p192_uint1)(x137 >> 22);
  x140 = (x137 & UINT32_C(0x3fffff));
  x141 = (x139 + x118);
  out1[0] = x140;
  out1[1] = x141;
  out1[2] = x124;
  out1[3] = x136;
  out1[4] = x138;
  out1[5] = x121;
  out1[6] = x127;
  out1[7] = x130;
  out1[8] = x133;
}

/*
 * The function fiat_p192_carry_scmul_3 multiplies a field element by 3 and reduces the result.
 * Postconditions:
 *   eval out1 mod m = (3 * eval arg1) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000]]
 */
static void fiat_p192_carry_scmul_3(uint32_t out1[9], const uint32_t arg1[9]) {
  uint32_t x1;
  uint32_t x2;
  uint32_t x3;
  uint32_t x4;
  uint32_t x5;
  uint32_t x6;
  uint32_t x7;
  uint32_t x8;
  uint32_t x9;
  uint32_t x10;
  uint32_t x11;
  uint32_t x12;
  uint32_t x13;
  uint32_t x14;
  uint32_t x15;
  uint32_t x16;
  uint32_t x17;
  uint32_t x18;
  uint32_t x19;
  uint32_t x20;
  uint32_t x21;
  uint32_t x22;
  uint32_t x23;
  uint32_t x24;
  uint32_t x25;
  uint32_t x26;
  uint32_t x27;
  uint32_t x28;
  uint32_t x29;
  uint32_t x30;
  uint32_t x31;
  fiat_p192_uint1 x32;
  uint32_t x33;
  uint32_t x34;
  uint32_t x35;
  uint32_t x36;
  uint32_t x37;
  uint32_t x38;
  uint32_t x39;
  uint32_t x40;
  fiat_p192_uint1 x41;
  uint32_t x42;
  uint32_t x43;
  fiat_p192_uint1 x44;
  uint32_t x45;
  uint32_t x46;
  uint32_t x47;
  fiat_p192_uint1 x48;
  uint32_t x49;
  uint32_t x50;
  x1 = ((arg1[8]) * 0x3);
  x2 = ((arg1[7]) * 0x3);
  x3 = ((arg1[6]) * 0x3);
  x4 = ((arg1[5]) * 0x3);
  x5 = ((arg1[4]) * 0x3);
  x6 = ((arg1[3]) * 0x3);
  x7 = ((arg1[2]) * 0x3);
  x8 = ((arg1[1]) * 0x3);
  x9 = ((arg1[0]) * 0x3);
  x10 = (x7 >> 21);
  x11 = (x7 & UINT32_C(0x1fffff));
  x12 = (x10 + x6);
  x13 = (x1 >> 21);
  x14 = (x1 & UINT32_C(0x1fffff));
  x15 = (x12 + x13);
  x16 = (x15 >> 22);
  x17 = (x15 & UINT32_C(0x3fffff));
  x18 = (x9 + x13);
  x19 = (x16 + x5);
  x20 = (x18 >> 22);
  x21 = (x18 & UINT32_C(0x3fffff));
  x22 = (x20 + x8);
  x23 = (x19 >> 21);
  x24 = (x19 & UINT32_C(0x1fffff));
  x25 = (x23 + x4);
  x26 = (x22 >> 21);
  x27 = (x22 & UINT32_C(0x1fffff));
  x28 = (x26 + x11);
  x29 = (x25 >> 21);
  x30 = (x25 & UINT32_C(0x1fffff));
  x31 = (x29 + x3);
  x32 = (fiat_p192_uint1)(x28 >> 21);
  x33 = (x28 & UINT32_C(0x1fffff));
  x34 = (x32 + x17);
  x35 = (x31 >> 22);
  x36 = (x31 & UINT32_C(0x3fffff));
  x37 = (x35 + x2);
  x38 = (x37 >> 21);
  x39 = (x37 & UINT32_C(0x1fffff));
  x40 = (x38 + x14);
  x41 = (fiat_p192_uint1)(x40 >> 21);
  x42 = (x40 & UINT32_C(0x1fffff));
  x43 = (x34 + (uint32_t)x41);
  x44 = (fiat_p192_uint1)(x43 >> 22);
  x45 = (x43 & UINT32_C(0x3fffff));
  x46 = (x21 + (uint32_t)x41);
  x47 = (x44 + x24);
  x48 = (fiat_p192_uint1)(x46 >> 22);
  x49 = (x46 & UINT32_C(0x3fffff));
  x50 = (x48 + x27);
  out1[0] = x49;
  out1[1] = x50;
  out1[2] = x33;
  out1[3] = x45;
  out1[4] = x47;
  out1[5] = x30;
  out1[6] = x36;
  out1[7] = x39;
  out1[8] = x42;
}

/*
 * The function fiat_p192_carry_scmul_4 multiplies a field element by 4 and reduces the result.
 * Postconditions:
 *   eval out1 mod m = (4 * eval arg1) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000]]
 */
static void fiat_p192_carry_scmul_4(uint32_t out1[9], const uint32_t arg1[9]) {
  uint32_t x1;
  uint32_t x2;
  uint32_t x3;
  uint32_t x4;
  uint32_t x5;
  uint32_t x6;
  uint32_t x7;
  uint32_t x8;
  uint32_t x9;
  uint32_t x10;
  uint32_t x11;
  uint32_t x12;
  uint32_t x13;
  uint32_t x14;
  uint32_t x15;
  uint32_t x16;
  uint32_t x17;
  uint32_t x18;
  uint32_t x19;
  uint32_t x20;
  uint32_t x21;
  uint32_t x22;
  uint32_t x23;
  uint32_t x24;
  uint32_t x25;
  uint32_t x26;
  uint32_t x27;
  uint32_t x28;
  uint32_t x29;
  uint32_t x30;
  uint32_t x31;
  fiat_p192_uint1 x32;
  uint32_t x33;
  uint32_t x34;
  uint32_t x35;
  uint32_t x36;
  uint32_t x37;
  uint32_t x38;
  uint32_t x39;
  uint32_t x40;
  fiat_p192_uint1 x41;
  uint32_t x42;
  uint32_t x43;
  fiat_p192_uint1 x44;
  uint32_t x45;
  uint32_t x46;
  uint32_t x47;
  fiat_p192_uint1 x48;
  uint32_t x49;
  uint32_t x50;
  x1 = ((arg1[8]) << 2);
  x2 = ((arg1[7]) << 2);
  x3 = ((arg1[6]) << 2);
  x4 = ((arg1[5]) << 2);
  x5 = ((arg1[4]) << 2);
  x6 = ((arg1[3]) << 2);
  x7 = ((arg1[2]) << 2);
  x8 = ((arg1[1]) << 2);
  x9 = ((arg1[0]) << 2);
  x10 = (x7 >> 21);
  x11 = (x7 & UINT32_C(0x1fffff));
  x12 = (x10 + x6);
  x13 = (x1 >> 21);
  x14 = (x1 & UINT32_C(0x1fffff));
  x15 = (x12 + x13);
  x16 = (x15 >> 22);
  x17 = (x15 & UINT32_C(0x3fffff));
  x18 = (x9 + x13);
  x19 = (x16 + x5);
  x20 = (x18 >> 22);
  x21 = (x18 & UINT32_C(0x3fffff));
  x22 = (x20 + x8);
  x23 = (x19 >> 21);
  x24 = (x19 & UINT32_C(0x1fffff));
  x25 = (x23 + x4);
  x26 = (x22 >> 21);
  x27 = (x22 & UINT32_C(0x1fffff));
  x28 = (x26 + x11);
  x29 = (x25 >> 21);
  x30 = (x25 & UINT32_C(0x1fffff));
  x31 = (x29 + x3);
  x32 = (fiat_p192_uint1)(x28 >> 21);
  x33 = (x28 & UINT32_C(0x1fffff));
  x34 = (x32 + x17);
  x35 = (x31 >> 22);
  x36 = (x31 & UINT32_C(0x3fffff));
  x37 = (x35 + x2);
  x38 = (x37 >> 21);
  x39 = (x37 & UINT32_C(0x1fffff));
  x40 = (x38 + x14);
  x41 = (fiat_p192_uint1)(x40 >> 21);
  x42 = (x40 & UINT32_C(0x1fffff));
  x43 = (x34 + (uint32_t)x41);
  x44 = (fiat_p192_uint1)(x43 >> 22);
  x45 = (x43 & UINT32_C(0x3fffff));
  x46 = (x21 + (uint32_t)x41);
  x47 = (x44 + x24);
  x48 = (fiat_p192_uint1)(x46 >> 22);
  x49 = (x46 & UINT32_C(0x3fffff));
  x50 = (x48 + x27);
  out1[0] = x49;
  out1[1] = x50;
  out1[2] = x33;
  out1[3] = x45;
  out1[4] = x47;
  out1[5] = x30;
  out1[6] = x36;
  out1[7] = x39;
  out1[8] = x42;
}

/*
 * The function fiat_p192_carry_scmul_8 multiplies a field element by 8 and reduces the result.
 * Postconditions:
 *   eval out1 mod m = (8 * eval arg1) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000], [0x0 ~> 0xc00000], [0x0 ~> 0x600000], [0x0 ~> 0x600000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000]]
 */
static void fiat_p192_carry_scmul_8(uint32_t out1[9], const uint32_t arg1[9]) {
  uint32_t x1;
  uint32_t x2;
  uint32_t x3;
  uint32_t x4;
  uint32_t x5;
  uint32_t x6;
  uint32_t x7;
  uint32_t x8;
  uint32_t x9;
  uint32_t x10;
  uint32_t x11;
  uint32_t x12;
  uint32_t x13;
  uint32_t x14;
  uint32_t x15;
  uint32_t x16;
  uint32_t x17;
  uint32_t x18;
  uint32_t x19;
  uint32_t x20;
  uint32_t x21;
  uint32_t x22;
  uint32_t x23;
  uint32_t x24;
  uint32_t x25;
  uint32_t x26;
  uint32_t x27;
  uint32_t x28;
  uint32_t x29;
  uint32_t x30;
  uint32_t x31;
  fiat_p192_uint1 x32;
  uint32_t x33;
  uint32_t x34;
  uint32_t x35;
  uint32_t x36;
  uint32_t x37;
  uint32_t x38;
  uint32_t x39;
  uint32_t x40;
  fiat_p192_uint1 x41;
  uint32_t x42;
  uint32_t x43;
  fiat_p192_uint1 x44;
  uint32_t x45;
  uint32_t x46;
  uint32_t x47;
  fiat_p192_uint1 x48;
  uint32_t x49;
  uint32_t x50;
  x1 = ((arg1[8]) << 3);
  x2 = ((arg1[7]) << 3);
  x3 = ((arg1[6]) << 3);
  x4 = ((arg1[5]) << 3);
  x5 = ((arg1[4]) << 3);
  x6 = ((arg1[3]) << 3);
  x7 = ((arg1[2]) << 3);
  x8 = ((arg1[1]) << 3);
  x9 = ((arg1[0]) << 3);
  x10 = (x7 >> 21);
  x11 = (x7 & UINT32_C(0x1fffff));
  x12 = (x10 + x6);
  x13 = (x1 >> 21);
  x14 = (x1 & UINT32_C(0x1fffff));
  x15 = (x12 + x13);
  x16 = (x15 >> 22);
  x17 = (x15 & UINT32_C(0x3fffff));
  x18 = (x9 + x13);
  x19 = (x16 + x5);
  x20 = (x18 >> 22);
  x21 = (x18 & UINT32_C(0x3fffff));
  x22 = (x20 + x8);
  x23 = (x19 >> 21);
  x24 = (x19 & UINT32_C(0x1fffff));
  x25 = (x23 + x4);
  x26 = (x22 >> 21);
  x27 = (x22 & UINT32_C(0x1fffff));
  x28 = (x26 + x11);
  x29 = (x25 >> 21);
  x30 = (x25 & UINT32_C(0x1fffff));
  x31 = (x29 + x3);
  x32 = (fiat_p192_uint1)(x28 >> 21);
  x33 = (x28 & UINT32_C(0x1fffff));
  x34 = (x32 + x17);
  x35 = (x31 >> 22);
  x36 = (x31 & UINT32_C(0x3fffff));
  x37 = (x35 + x2);
  x38 = (x37 >> 21);
  x39 = (x37 & UINT32_C(0x1fffff));
  x40 = (x38 + x14);
  x41 = (fiat_p192_uint1)(x40 >> 21);
  x42 = (x40 & UINT32_C(0x1fffff));
  x43 = (x34 + (uint32_t)x41);
  x44 = (fiat_p192_uint1)(x43 >> 22);
  x45 = (x43 & UINT32_C(0x3fffff));
  x46 = (x21 + (uint32_t)x41);
  x47 = (x44 + x24);
  x48 = (fiat_p192_uint1)(x46 >> 22);
  x49 = (x46 & UINT32_C(0x3fffff));
  x50 = (x48 + x27);
  out1[0] = x49;
  out1[1] = x50;
  out1[2] = x33;
  out1[3] = x45;
  out1[4] = x47;
  out1[5] = x30;
  out1[6] = x36;
  out1[7] = x39;
  out1[8] = x42;
}

/*
 * The function fiat_p192_selectznz is a multi-limb conditional select.
 * Postconditions:
 *   eval out1 = (if arg1 = 0 then eval arg2 else eval arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 *   arg3: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 */
static void fiat_p192_selectznz(uint32_t out1[9], fiat_p192_uint1 arg1, const uint32_t arg2[9], const uint32_t arg3[9]) {
  uint32_t x1;
  uint32_t x2;
  uint32_t x3;
  uint32_t x4;
  uint32_t x5;
  uint32_t x6;
  uint32_t x7;
  uint32_t x8;
  uint32_t x9;
  fiat_p192_cmovznz_u32(&x1, arg1, (arg2[0]), (arg3[0]));
  fiat_p192_cmovznz_u32(&x2, arg1, (arg2[1]), (arg3[1]));
  fiat_p192_cmovznz_u32(&x3, arg1, (arg2[2]), (arg3[2]));
  fiat_p192_cmovznz_u32(&x4, arg1, (arg2[3]), (arg3[3]));
  fiat_p192_cmovznz_u32(&x5, arg1, (arg2[4]), (arg3[4]));
  fiat_p192_cmovznz_u32(&x6, arg1, (arg2[5]), (arg3[5]));
  fiat_p192_cmovznz_u32(&x7, arg1, (arg2[6]), (arg3[6]));
  fiat_p192_cmovznz_u32(&x8, arg1, (arg2[7]), (arg3[7]));
  fiat_p192_cmovznz_u32(&x9, arg1, (arg2[8]), (arg3[8]));
  out1[0] = x1;
  out1[1] = x2;
  out1[2] = x3;
  out1[3] = x4;
  out1[4] = x5;
  out1[5] = x6;
  out1[6] = x7;
  out1[7] = x8;
  out1[8] = x9;
}

/*
 * The function fiat_p192_to_bytes serializes a field element to bytes in little-endian order.
 * Postconditions:
 *   out1 = map (λ x, ⌊((eval arg1 mod m) mod 2^(8 * (x + 1))) / 2^(8 * x)⌋) [0..23]
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]
 */
static void fiat_p192_to_bytes(uint8_t out1[24], const uint32_t arg1[9]) {
  uint32_t x1;
  fiat_p192_uint1 x2;
  uint32_t x3;
  fiat_p192_uint1 x4;
  uint32_t x5;
  fiat_p192_uint1 x6;
  uint32_t x7;
  fiat_p192_uint1 x8;
  uint32_t x9;
  fiat_p192_uint1 x10;
  uint32_t x11;
  fiat_p192_uint1 x12;
  uint32_t x13;
  fiat_p192_uint1 x14;
  uint32_t x15;
  fiat_p192_uint1 x16;
  uint32_t x17;
  fiat_p192_uint1 x18;
  uint32_t x19;
  uint32_t x20;
  fiat_p192_uint1 x21;
  uint32_t x22;
  fiat_p192_uint1 x23;
  uint32_t x24;
  fiat_p192_uint1 x25;
  uint32_t x26;
  fiat_p192_uint1 x27;
  uint32_t x28;
  fiat_p192_uint1 x29;
  uint32_t x30;
  fiat_p192_uint1 x31;
  uint32_t x32;
  fiat_p192_uint1 x33;
  uint32_t x34;
  fiat_p192_uint1 x35;
  uint32_t x36;
  fiat_p192_uint1 x37;
  uint32_t x38;
  uint32_t x39;
  uint32_t x40;
  uint32_t x41;
  uint32_t x42;
  uint32_t x43;
  uint8_t x44;
  uint32_t x45;
  uint8_t x46;
  uint8_t x47;
  uint32_t x48;
  uint8_t x49;
  uint32_t x50;
  uint8_t x51;
  uint32_t x52;
  uint8_t x53;
  uint8_t x54;
  uint32_t x55;
  uint8_t x56;
  uint32_t x57;
  uint8_t x58;
  uint8_t x59;
  uint8_t x60;
  uint32_t x61;
  uint8_t x62;
  uint8_t x63;
  uint32_t x64;
  uint8_t x65;
  uint32_t x66;
  uint8_t x67;
  uint32_t x68;
  uint8_t x69;
  uint8_t x70;
  uint32_t x71;
  uint8_t x72;
  uint32_t x73;
  uint8_t x74;
  uint8_t x75;
  uint8_t x76;
  uint32_t x77;
  uint8_t x78;
  uint8_t x79;
  uint32_t x80;
  uint8_t x81;
  uint32_t x82;
  uint8_t x83;
  uint32_t x84;
  uint8_t x85;
  uint8_t x86;
  uint32_t x87;
  uint8_t x88;
  uint32_t x89;
  uint8_t x90;
  uint8_t x91;
  fiat_p192_subborrowx_u22(&x1, &x2, 0x0, (arg1[0]), UINT32_C(0x3fffff));
  fiat_p192_subborrowx_u21(&x3, &x4, x2, (arg1[1]), UINT32_C(0x1fffff));
  fiat_p192_subborrowx_u21(&x5, &x6, x4, (arg1[2]), UINT32_C(0x1fffff));
  fiat_p192_subborrowx_u22(&x7, &x8, x6, (arg1[3]), UINT32_C(0x3ffffe));
  fiat_p192_subborrowx_u21(&x9, &x10, x8, (arg1[4]), UINT32_C(0x1fffff));
  fiat_p192_subborrowx_u21(&x11, &x12, x10, (arg1[5]), UINT32_C(0x1fffff));
  fiat_p192_subborrowx_u22(&x13, &x14, x12, (arg1[6]), UINT32_C(0x3fffff));
  fiat_p192_subborrowx_u21(&x15, &x16, x14, (arg1[7]), UINT32_C(0x1fffff));
  fiat_p192_subborrowx_u21(&x17, &x18, x16, (arg1[8]), UINT32_C(0x1fffff));
  fiat_p192_cmovznz_u32(&x19, x18, 0x0, UINT32_C(0xffffffff));
  fiat_p192_addcarryx_u22(&x20, &x21, 0x0, x1, (x19 & UINT32_C(0x3fffff)));
  fiat_p192_addcarryx_u21(&x22, &x23, x21, x3, (x19 & UINT32_C(0x1fffff)));
  fiat_p192_addcarryx_u21(&x24, &x25, x23, x5, (x19 & UINT32_C(0x1fffff)));
  fiat_p192_addcarryx_u22(&x26, &x27, x25, x7, (x19 & UINT32_C(0x3ffffe)));
  fiat_p192_addcarryx_u21(&x28, &x29, x27, x9, (x19 & UINT32_C(0x1fffff)));
  fiat_p192_addcarryx_u21(&x30, &x31, x29, x11, (x19 & UINT32_C(0x1fffff)));
  fiat_p192_addcarryx_u22(&x32, &x33, x31, x13, (x19 & UINT32_C(0x3fffff)));
  fiat_p192_addcarryx_u21(&x34, &x35, x33, x15, (x19 & UINT32_C(0x1fffff)));
  fiat_p192_addcarryx_u21(&x36, &x37, x35, x17, (x19 & UINT32_C(0x1fffff)));
  x38 = (x36 << 3);
  x39 = (x34 << 6);
  x40 = (x30 << 3);
  x41 = (x28 << 6);
  x42 = (x24 << 3);
  x43 = (x22 << 6);
  x44 = (uint8_t)(x20 & UINT8_C(0xff));
  x45 = (x20 >> 8);
  x46 = (uint8_t)(x45 & UINT8_C(0xff));
  x47 = (uint8_t)(x45 >> 8);
  x48 = (x43 + (uint32_t)x47);
  x49 = (uint8_t)(x48 & UINT8_C(0xff));
  x50 = (x48 >> 8);
  x51 = (uint8_t)(x50 & UINT8_C(0xff));
  x52 = (x50 >> 8);
  x53 = (uint8_t)(x52 & UINT8_C(0xff));
  x54 = (uint8_t)(x52 >> 8);
  x55 = (x42 + (uint32_t)x54);
  x56 = (uint8_t)(x55 & UINT8_C(0xff));
  x57 = (x55 >> 8);
  x58 = (uint8_t)(x57 & UINT8_C(0xff));
  x59 = (uint8_t)(x57 >> 8);
  x60 = (uint8_t)(x26 & UINT8_C(0xff));
  x61 = (x26 >> 8);
  x62 = (uint8_t)(x61 & UINT8_C(0xff));
  x63 = (uint8_t)(x61 >> 8);
  x64 = (x41 + (uint32_t)x63);
  x65 = (uint8_t)(x64 & UINT8_C(0xff));
  x66 = (x64 >> 8);
  x67 = (uint8_t)(x66 & UINT8_C(0xff));
  x68 = (x66 >> 8);
  x69 = (uint8_t)(x68 & UINT8_C(0xff));
  x70 = (uint8_t)(x68 >> 8);
  x71 = (x40 + (uint32_t)x70);
  x72 = (uint8_t)(x71 & UINT8_C(0xff));
  x73 = (x71 >> 8);
  x74 = (uint8_t)(x73 & UINT8_C(0xff));
  x75 = (uint8_t)(x73 >> 8);
  x76 = (uint8_t)(x32 & UINT8_C(0xff));
  x77 = (x32 >> 8);
  x78 = (uint8_t)(x77 & UINT8_C(0xff));
  x79 = (uint8_t)(x77 >> 8);
  x80 = (x39 + (uint32_t)x79);
  x81 = (uint8_t)(x80 & UINT8_C(0xff));
  x82 = (x80 >> 8);
  x83 = (uint8_t)(x82 & UINT8_C(0xff));
  x84 = (x82 >> 8);
  x85 = (uint8_t)(x84 & UINT8_C(0xff));
  x86 = (uint8_t)(x84 >> 8);
  x87 = (x38 + (uint32_t)x86);
  x88 = (uint8_t)(x87 & UINT8_C(0xff));
  x89 = (x87 >> 8);
  x90 = (uint8_t)(x89 & UINT8_C(0xff));
  x91 = (uint8_t)(x89 >> 8);
  out1[0] = x44;
  out1[1] = x46;
  out1[2] = x49;
  out1[3] = x51;
  out1[4] = x53;
  out1[5] = x56;
  out1[6] = x58;
  out1[7] = x59;
  out1[8] = x60;
  out1[9] = x62;
  out1[10] = x65;
  out1[11] = x67;
  out1[12] = x69;
  out1[13] = x72;
  out1[14] = x74;
  out1[15] = x75;
  out1[16] = x76;
  out1[17] = x78;
  out1[18] = x81;
  out1[19] = x83;
  out1[20] = x85;
  out1[21] = x88;
  out1[22] = x90;
  out1[23] = x91;
}

/*
 * The function fiat_p192_from_bytes deserializes a field element from bytes in little-endian order.
 * Postconditions:
 *   eval out1 mod m = bytes_eval arg1 mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000], [0x0 ~> 0x400000], [0x0 ~> 0x200000], [0x0 ~> 0x200000]]
 */
static void fiat_p192_from_bytes(uint32_t out1[9], const uint8_t arg1[24]) {
  uint32_t x1;
  uint32_t x2;
  uint32_t x3;
  uint32_t x4;
  uint32_t x5;
  uint32_t x6;
  uint32_t x7;
  uint8_t x8;
  uint32_t x9;
  uint32_t x10;
  uint32_t x11;
  uint32_t x12;
  uint32_t x13;
  uint32_t x14;
  uint32_t x15;
  uint8_t x16;
  uint32_t x17;
  uint32_t x18;
  uint32_t x19;
  uint32_t x20;
  uint32_t x21;
  uint32_t x22;
  uint32_t x23;
  uint8_t x24;
  uint32_t x25;
  uint32_t x26;
  uint32_t x27;
  uint8_t x28;
  uint32_t x29;
  uint32_t x30;
  uint32_t x31;
  uint32_t x32;
  uint8_t x33;
  uint32_t x34;
  uint32_t x35;
  uint32_t x36;
  uint32_t x37;
  uint32_t x38;
  uint8_t x39;
  uint32_t x40;
  uint32_t x41;
  uint32_t x42;
  uint32_t x43;
  uint8_t x44;
  uint32_t x45;
  uint32_t x46;
  uint32_t x47;
  uint32_t x48;
  uint32_t x49;
  uint8_t x50;
  uint32_t x51;
  uint32_t x52;
  uint32_t x53;
  uint32_t x54;
  uint8_t x55;
  uint32_t x56;
  uint32_t x57;
  x1 = ((uint32_t)(arg1[23]) << 13);
  x2 = ((uint32_t)(arg1[22]) << 5);
  x3 = ((uint32_t)(arg1[21]) << 18);
  x4 = ((uint32_t)(arg1[20]) << 10);
  x5 = ((uint32_t)(arg1[19]) << 2);
  x6 = ((uint32_t)(arg1[18]) << 16);
  x7 = ((uint32_t)(arg1[17]) << 8);
  x8 = (arg1[16]);
  x9 = ((uint32_t)(arg1[15]) << 13);
  x10 = ((uint32_t)(arg1[14]) << 5);
  x11 = ((uint32_t)(arg1[13]) << 18);
  x12 = ((uint32_t)(arg1[12]) << 10);
  x13 = ((uint32_t)(arg1[11]) << 2);
  x14 = ((uint32_t)(arg1[10]) << 16);
  x15 = ((uint32_t)(arg1[9]) << 8);
  x16 = (arg1[8]);
  x17 = ((uint32_t)(arg1[7]) << 13);
  x18 = ((uint32_t)(arg1[6]) << 5);
  x19 = ((uint32_t)(arg1[5]) << 18);
  x20 = ((uint32_t)(arg1[4]) << 10);
  x21 = ((uint32_t)(arg1[3]) << 2);
  x22 = ((uint32_t)(arg1[2]) << 16);
  x23 = ((uint32_t)(arg1[1]) << 8);
  x24 = (arg1[0]);
  x25 = (x23 + (uint32_t)x24);
  x26 = (x22 + x25);
  x27 = (x26 & UINT32_C(0x3fffff));
  x28 = (uint8_t)(x26 >> 22);
  x29 = (x21 + (uint32_t)x28);
  x30 = (x20 + x29);
  x31 = (x19 + x30);
  x32 = (x31 & UINT32_C(0x1fffff));
  x33 = (uint8_t)(x31 >> 21);
  x34 = (x18 + (uint32_t)x33);
  x35 = (x17 + x34);
  x36 = (x15 + (uint32_t)x16);
  x37 = (x14 + x36);
  x38 = (x37 & UINT32_C(0x3fffff));
  x39 = (uint8_t)(x37 >> 22);
  x40 = (x13 + (uint32_t)x39);
  x41 = (x12 + x40);
  x42 = (x11 + x41);
  x43 = (x42 & UINT32_C(0x1fffff));
  x44 = (uint8_t)(x42 >> 21);
  x45 = (x10 + (uint32_t)x44);
  x46 = (x9 + x45);
  x47 = (x7 + (uint32_t)x8);
  x48 = (x6 + x47);
  x49 = (x48 & UINT32_C(0x3fffff));
  x50 = (uint8_t)(x48 >> 22);
  x51 = (x5 + (uint32_t)x50);
  x52 = (x4 + x51);
  x53 = (x3 + x52);
  x54 = (x53 & UINT32_C(0x1fffff));
  x55 = (uint8_t)(x53 >> 21);
  x56 = (x2 + (uint32_t)x55);
  x57 = (x1 + x56);
  out1[0] = x27;
  out1[1] = x32;
  out1[2] = x35;
  out1[3] = x38;
  out1[4] = x43;
  out1[5] = x46;
  out1[6] = x49;
  out1[7] = x54;
  out1[8] = x57;
}
