/* Autogenerated: /src/ExtractionOCaml/unsaturated_solinas --static p192 64 4 '2^192 - 2^64 - 1' add sub opp carry carry_mul carry_square carry_scmul3 carry_scmul4 carry_scmul8 selectznz to_bytes from_bytes */
/* curve description: p192 */
/* machine_wordsize = 64 (from "64") */
/* requested operations: add, sub, opp, carry, carry_mul, carry_square, carry_scmul3, carry_scmul4, carry_scmul8, selectznz, to_bytes, from_bytes */
/* n = 4 (from "4") */
/* s-c = 2^192 - [(2^64, 1), (1, 1)] (from "2^192 - 2^64 - 1") */
/* tight_bounds_multiplier = 1 (from "") */
/*  */
/* Computed values: */
/* carry_chain = [0, 3, 1, 0, 2, 3, 1, 0] */
/* eval z = z[0] + (z[1] << 48) + (z[2] << 96) + (z[3] << 144) */
/* bytes_eval z = z[0] + (z[1] << 8) + (z[2] << 16) + (z[3] << 24) + (z[4] << 32) + (z[5] << 40) + (z[6] << 48) + (z[7] << 56) + (z[8] << 64) + (z[9] << 72) + (z[10] << 80) + (z[11] << 88) + (z[12] << 96) + (z[13] << 104) + (z[14] << 112) + (z[15] << 120) + (z[16] << 128) + (z[17] << 136) + (z[18] << 144) + (z[19] << 152) + (z[20] << 160) + (z[21] << 168) + (z[22] << 176) + (z[23] << 184) */
/* balance = [0x1fffffffffffe, 0x1fffffffdfffe, 0x1fffffffffffe, 0x1fffffffffffe] */

#include <stdint.h>
typedef unsigned char fiat_p192_uint1;
typedef signed char fiat_p192_int1;
typedef torsion_int128_t fiat_p192_int128;
typedef torsion_uint128_t fiat_p192_uint128;

#if (-1 & 3) != 3
#error "This code only works on a two's complement system"
#endif


/*
 * The function fiat_p192_addcarryx_u48 is an addition with carry.
 * Postconditions:
 *   out1 = (arg1 + arg2 + arg3) mod 2^48
 *   out2 = ⌊(arg1 + arg2 + arg3) / 2^48⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffff]
 *   out2: [0x0 ~> 0x1]
 */
static void fiat_p192_addcarryx_u48(uint64_t* out1, fiat_p192_uint1* out2, fiat_p192_uint1 arg1, uint64_t arg2, uint64_t arg3) {
  uint64_t x1;
  uint64_t x2;
  fiat_p192_uint1 x3;
  x1 = ((arg1 + arg2) + arg3);
  x2 = (x1 & UINT64_C(0xffffffffffff));
  x3 = (fiat_p192_uint1)(x1 >> 48);
  *out1 = x2;
  *out2 = x3;
}

/*
 * The function fiat_p192_subborrowx_u48 is a subtraction with borrow.
 * Postconditions:
 *   out1 = (-arg1 + arg2 + -arg3) mod 2^48
 *   out2 = -⌊(-arg1 + arg2 + -arg3) / 2^48⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffff]
 *   out2: [0x0 ~> 0x1]
 */
static void fiat_p192_subborrowx_u48(uint64_t* out1, fiat_p192_uint1* out2, fiat_p192_uint1 arg1, uint64_t arg2, uint64_t arg3) {
  int64_t x1;
  fiat_p192_int1 x2;
  uint64_t x3;
  x1 = ((int64_t)(arg2 - (int64_t)arg1) - (int64_t)arg3);
  x2 = (fiat_p192_int1)(x1 >> 48);
  x3 = (x1 & UINT64_C(0xffffffffffff));
  *out1 = x3;
  *out2 = (fiat_p192_uint1)(0x0 - x2);
}

/*
 * The function fiat_p192_cmovznz_u64 is a single-word conditional move.
 * Postconditions:
 *   out1 = (if arg1 = 0 then arg2 else arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 */
static void fiat_p192_cmovznz_u64(uint64_t* out1, fiat_p192_uint1 arg1, uint64_t arg2, uint64_t arg3) {
  fiat_p192_uint1 x1;
  uint64_t x2;
  uint64_t x3;
  x1 = (!(!arg1));
  x2 = ((fiat_p192_int1)(0x0 - x1) & UINT64_C(0xffffffffffffffff));
  x3 = ((fe_word_barrier(x2) & arg3) | (fe_word_barrier(~x2) & arg2));
  *out1 = x3;
}

/*
 * The function fiat_p192_add adds two field elements.
 * Postconditions:
 *   eval out1 mod m = (eval arg1 + eval arg2) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000]]
 *   arg2: [[0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000]]
 */
static void fiat_p192_add(uint64_t out1[4], const uint64_t arg1[4], const uint64_t arg2[4]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  x1 = ((arg1[0]) + (arg2[0]));
  x2 = ((arg1[1]) + (arg2[1]));
  x3 = ((arg1[2]) + (arg2[2]));
  x4 = ((arg1[3]) + (arg2[3]));
  out1[0] = x1;
  out1[1] = x2;
  out1[2] = x3;
  out1[3] = x4;
}

/*
 * The function fiat_p192_sub subtracts two field elements.
 * Postconditions:
 *   eval out1 mod m = (eval arg1 - eval arg2) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000]]
 *   arg2: [[0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000]]
 */
static void fiat_p192_sub(uint64_t out1[4], const uint64_t arg1[4], const uint64_t arg2[4]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  x1 = ((UINT64_C(0x1fffffffffffe) + (arg1[0])) - (arg2[0]));
  x2 = ((UINT64_C(0x1fffffffdfffe) + (arg1[1])) - (arg2[1]));
  x3 = ((UINT64_C(0x1fffffffffffe) + (arg1[2])) - (arg2[2]));
  x4 = ((UINT64_C(0x1fffffffffffe) + (arg1[3])) - (arg2[3]));
  out1[0] = x1;
  out1[1] = x2;
  out1[2] = x3;
  out1[3] = x4;
}

/*
 * The function fiat_p192_opp negates a field element.
 * Postconditions:
 *   eval out1 mod m = -eval arg1 mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000]]
 */
static void fiat_p192_opp(uint64_t out1[4], const uint64_t arg1[4]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  x1 = (UINT64_C(0x1fffffffffffe) - (arg1[0]));
  x2 = (UINT64_C(0x1fffffffdfffe) - (arg1[1]));
  x3 = (UINT64_C(0x1fffffffffffe) - (arg1[2]));
  x4 = (UINT64_C(0x1fffffffffffe) - (arg1[3]));
  out1[0] = x1;
  out1[1] = x2;
  out1[2] = x3;
  out1[3] = x4;
}

/*
 * The function fiat_p192_carry reduces a field element.
 * Postconditions:
 *   eval out1 mod m = eval arg1 mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000]]
 */
static void fiat_p192_carry(uint64_t out1[4], const uint64_t arg1[4]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  fiat_p192_uint1 x8;
  uint64_t x9;
  uint64_t x10;
  uint64_t x11;
  uint64_t x12;
  uint64_t x13;
  uint64_t x14;
  x1 = (arg1[0]);
  x2 = (arg1[3]);
  x3 = (x2 >> 48);
  x4 = (((x1 >> 48) + (arg1[1])) + (x3 << 16));
  x5 = ((x1 & UINT64_C(0xffffffffffff)) + x3);
  x6 = ((x4 >> 48) + (arg1[2]));
  x7 = ((x6 >> 48) + (x2 & UINT64_C(0xffffffffffff)));
  x8 = (fiat_p192_uint1)(x7 >> 48);
  x9 = (((fiat_p192_uint1)(x5 >> 48) + (x4 & UINT64_C(0xffffffffffff))) + ((uint64_t)x8 << 16));
  x10 = ((x5 & UINT64_C(0xffffffffffff)) + (uint64_t)x8);
  x11 = (x10 & UINT64_C(0xffffffffffff));
  x12 = ((fiat_p192_uint1)(x10 >> 48) + (x9 & UINT64_C(0xffffffffffff)));
  x13 = ((fiat_p192_uint1)(x9 >> 48) + (x6 & UINT64_C(0xffffffffffff)));
  x14 = (x7 & UINT64_C(0xffffffffffff));
  out1[0] = x11;
  out1[1] = x12;
  out1[2] = x13;
  out1[3] = x14;
}

/*
 * The function fiat_p192_carry_mul multiplies two field elements and reduces the result.
 * Postconditions:
 *   eval out1 mod m = (eval arg1 * eval arg2) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000]]
 *   arg2: [[0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000]]
 */
static void fiat_p192_carry_mul(uint64_t out1[4], const uint64_t arg1[4], const uint64_t arg2[4]) {
  fiat_p192_uint128 x1;
  fiat_p192_uint128 x2;
  fiat_p192_uint128 x3;
  fiat_p192_uint128 x4;
  fiat_p192_uint128 x5;
  fiat_p192_uint128 x6;
  fiat_p192_uint128 x7;
  fiat_p192_uint128 x8;
  fiat_p192_uint128 x9;
  fiat_p192_uint128 x10;
  fiat_p192_uint128 x11;
  fiat_p192_uint128 x12;
  fiat_p192_uint128 x13;
  fiat_p192_uint128 x14;
  fiat_p192_uint128 x15;
  fiat_p192_uint128 x16;
  fiat_p192_uint128 x17;
  fiat_p192_uint128 x18;
  fiat_p192_uint128 x19;
  fiat_p192_uint128 x20;
  fiat_p192_uint128 x21;
  fiat_p192_uint128 x22;
  fiat_p192_uint128 x23;
  uint64_t x24;
  uint64_t x25;
  fiat_p192_uint128 x26;
  fiat_p192_uint128 x27;
  fiat_p192_uint128 x28;
  fiat_p192_uint128 x29;
  fiat_p192_uint128 x30;
  uint64_t x31;
  fiat_p192_uint128 x32;
  fiat_p192_uint128 x33;
  fiat_p192_uint128 x34;
  uint64_t x35;
  fiat_p192_uint128 x36;
  fiat_p192_uint128 x37;
  uint64_t x38;
  uint64_t x39;
  uint64_t x40;
  fiat_p192_uint128 x41;
  uint64_t x42;
  fiat_p192_uint128 x43;
  uint64_t x44;
  uint64_t x45;
  uint64_t x46;
  uint64_t x47;
  fiat_p192_uint1 x48;
  uint64_t x49;
  uint64_t x50;
  uint64_t x51;
  fiat_p192_uint1 x52;
  uint64_t x53;
  uint64_t x54;
  x1 = ((fiat_p192_uint128)(arg1[3]) * (arg2[3]));
  x2 = ((fiat_p192_uint128)(arg1[3]) * (arg2[2]));
  x3 = ((fiat_p192_uint128)(arg1[3]) * (arg2[1]));
  x4 = ((fiat_p192_uint128)(arg1[2]) * (arg2[3]));
  x5 = ((fiat_p192_uint128)(arg1[2]) * (arg2[2]));
  x6 = ((fiat_p192_uint128)(arg1[1]) * (arg2[3]));
  x7 = (((fiat_p192_uint128)(arg1[3]) * (arg2[3])) << 16);
  x8 = (((fiat_p192_uint128)(arg1[3]) * (arg2[2])) << 16);
  x9 = (((fiat_p192_uint128)(arg1[3]) * (arg2[1])) << 16);
  x10 = (((fiat_p192_uint128)(arg1[2]) * (arg2[3])) << 16);
  x11 = (((fiat_p192_uint128)(arg1[2]) * (arg2[2])) << 16);
  x12 = (((fiat_p192_uint128)(arg1[1]) * (arg2[3])) << 16);
  x13 = ((fiat_p192_uint128)(arg1[3]) * (arg2[0]));
  x14 = ((fiat_p192_uint128)(arg1[2]) * (arg2[1]));
  x15 = ((fiat_p192_uint128)(arg1[2]) * (arg2[0]));
  x16 = ((fiat_p192_uint128)(arg1[1]) * (arg2[2]));
  x17 = ((fiat_p192_uint128)(arg1[1]) * (arg2[1]));
  x18 = ((fiat_p192_uint128)(arg1[1]) * (arg2[0]));
  x19 = ((fiat_p192_uint128)(arg1[0]) * (arg2[3]));
  x20 = ((fiat_p192_uint128)(arg1[0]) * (arg2[2]));
  x21 = ((fiat_p192_uint128)(arg1[0]) * (arg2[1]));
  x22 = ((fiat_p192_uint128)(arg1[0]) * (arg2[0]));
  x23 = (x22 + (x6 + (x5 + x3)));
  x24 = (uint64_t)(x23 >> 48);
  x25 = (uint64_t)(x23 & UINT64_C(0xffffffffffff));
  x26 = (x19 + (x16 + (x14 + (x13 + x7))));
  x27 = (x20 + (x17 + (x15 + (x10 + (x8 + x1)))));
  x28 = (x21 + (x18 + (x12 + (x11 + (x9 + (x4 + x2))))));
  x29 = (x24 + x28);
  x30 = (x26 >> 48);
  x31 = (uint64_t)(x26 & UINT64_C(0xffffffffffff));
  x32 = (x30 << 16);
  x33 = (x29 + x32);
  x34 = (x33 >> 48);
  x35 = (uint64_t)(x33 & UINT64_C(0xffffffffffff));
  x36 = (x25 + x30);
  x37 = (x34 + x27);
  x38 = (uint64_t)(x36 >> 48);
  x39 = (uint64_t)(x36 & UINT64_C(0xffffffffffff));
  x40 = (x38 + x35);
  x41 = (x37 >> 48);
  x42 = (uint64_t)(x37 & UINT64_C(0xffffffffffff));
  x43 = (x41 + x31);
  x44 = (uint64_t)(x43 >> 48);
  x45 = (uint64_t)(x43 & UINT64_C(0xffffffffffff));
  x46 = (x44 << 16);
  x47 = (x40 + x46);
  x48 = (fiat_p192_uint1)(x47 >> 48);
  x49 = (x47 & UINT64_C(0xffffffffffff));
  x50 = (x39 + x44);
  x51 = (x48 + x42);
  x52 = (fiat_p192_uint1)(x50 >> 48);
  x53 = (x50 & UINT64_C(0xffffffffffff));
  x54 = (x52 + x49);
  out1[0] = x53;
  out1[1] = x54;
  out1[2] = x51;
  out1[3] = x45;
}

/*
 * The function fiat_p192_carry_square squares a field element and reduces the result.
 * Postconditions:
 *   eval out1 mod m = (eval arg1 * eval arg1) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000]]
 */
static void fiat_p192_carry_square(uint64_t out1[4], const uint64_t arg1[4]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  uint64_t x9;
  fiat_p192_uint128 x10;
  fiat_p192_uint128 x11;
  fiat_p192_uint128 x12;
  fiat_p192_uint128 x13;
  fiat_p192_uint128 x14;
  fiat_p192_uint128 x15;
  fiat_p192_uint128 x16;
  fiat_p192_uint128 x17;
  fiat_p192_uint128 x18;
  fiat_p192_uint128 x19;
  fiat_p192_uint128 x20;
  fiat_p192_uint128 x21;
  fiat_p192_uint128 x22;
  fiat_p192_uint128 x23;
  fiat_p192_uint128 x24;
  uint64_t x25;
  uint64_t x26;
  fiat_p192_uint128 x27;
  fiat_p192_uint128 x28;
  fiat_p192_uint128 x29;
  fiat_p192_uint128 x30;
  fiat_p192_uint128 x31;
  uint64_t x32;
  fiat_p192_uint128 x33;
  fiat_p192_uint128 x34;
  fiat_p192_uint128 x35;
  uint64_t x36;
  fiat_p192_uint128 x37;
  fiat_p192_uint128 x38;
  uint64_t x39;
  uint64_t x40;
  uint64_t x41;
  fiat_p192_uint128 x42;
  uint64_t x43;
  fiat_p192_uint128 x44;
  uint64_t x45;
  uint64_t x46;
  uint64_t x47;
  uint64_t x48;
  fiat_p192_uint1 x49;
  uint64_t x50;
  uint64_t x51;
  uint64_t x52;
  fiat_p192_uint1 x53;
  uint64_t x54;
  uint64_t x55;
  x1 = (arg1[3]);
  x2 = (arg1[3]);
  x3 = (x1 * 0x2);
  x4 = (x2 * 0x2);
  x5 = ((arg1[3]) * 0x2);
  x6 = (arg1[2]);
  x7 = (arg1[2]);
  x8 = ((arg1[2]) * 0x2);
  x9 = ((arg1[1]) * 0x2);
  x10 = ((fiat_p192_uint128)(arg1[3]) * x2);
  x11 = (((fiat_p192_uint128)(arg1[3]) * x1) << 16);
  x12 = ((fiat_p192_uint128)(arg1[2]) * x4);
  x13 = (((fiat_p192_uint128)(arg1[2]) * x3) << 16);
  x14 = ((fiat_p192_uint128)(arg1[2]) * x7);
  x15 = (((fiat_p192_uint128)(arg1[2]) * x6) << 16);
  x16 = ((fiat_p192_uint128)(arg1[1]) * x4);
  x17 = (((fiat_p192_uint128)(arg1[1]) * x3) << 16);
  x18 = ((fiat_p192_uint128)(arg1[1]) * x8);
  x19 = ((fiat_p192_uint128)(arg1[1]) * (arg1[1]));
  x20 = ((fiat_p192_uint128)(arg1[0]) * x5);
  x21 = ((fiat_p192_uint128)(arg1[0]) * x8);
  x22 = ((fiat_p192_uint128)(arg1[0]) * x9);
  x23 = ((fiat_p192_uint128)(arg1[0]) * (arg1[0]));
  x24 = (x23 + (x16 + x14));
  x25 = (uint64_t)(x24 >> 48);
  x26 = (uint64_t)(x24 & UINT64_C(0xffffffffffff));
  x27 = (x20 + (x18 + x11));
  x28 = (x21 + (x19 + (x13 + x10)));
  x29 = (x22 + (x17 + (x15 + x12)));
  x30 = (x25 + x29);
  x31 = (x27 >> 48);
  x32 = (uint64_t)(x27 & UINT64_C(0xffffffffffff));
  x33 = (x31 << 16);
  x34 = (x30 + x33);
  x35 = (x34 >> 48);
  x36 = (uint64_t)(x34 & UINT64_C(0xffffffffffff));
  x37 = (x26 + x31);
  x38 = (x35 + x28);
  x39 = (uint64_t)(x37 >> 48);
  x40 = (uint64_t)(x37 & UINT64_C(0xffffffffffff));
  x41 = (x39 + x36);
  x42 = (x38 >> 48);
  x43 = (uint64_t)(x38 & UINT64_C(0xffffffffffff));
  x44 = (x42 + x32);
  x45 = (uint64_t)(x44 >> 48);
  x46 = (uint64_t)(x44 & UINT64_C(0xffffffffffff));
  x47 = (x45 << 16);
  x48 = (x41 + x47);
  x49 = (fiat_p192_uint1)(x48 >> 48);
  x50 = (x48 & UINT64_C(0xffffffffffff));
  x51 = (x40 + x45);
  x52 = (x49 + x43);
  x53 = (fiat_p192_uint1)(x51 >> 48);
  x54 = (x51 & UINT64_C(0xffffffffffff));
  x55 = (x53 + x50);
  out1[0] = x54;
  out1[1] = x55;
  out1[2] = x52;
  out1[3] = x46;
}

/*
 * The function fiat_p192_carry_scmul_3 multiplies a field element by 3 and reduces the result.
 * Postconditions:
 *   eval out1 mod m = (3 * eval arg1) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000]]
 */
static void fiat_p192_carry_scmul_3(uint64_t out1[4], const uint64_t arg1[4]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  uint64_t x9;
  uint64_t x10;
  uint64_t x11;
  uint64_t x12;
  uint64_t x13;
  uint64_t x14;
  uint64_t x15;
  fiat_p192_uint1 x16;
  uint64_t x17;
  uint64_t x18;
  uint64_t x19;
  uint64_t x20;
  uint64_t x21;
  fiat_p192_uint1 x22;
  uint64_t x23;
  uint64_t x24;
  uint64_t x25;
  fiat_p192_uint1 x26;
  uint64_t x27;
  uint64_t x28;
  uint64_t x29;
  fiat_p192_uint1 x30;
  uint64_t x31;
  uint64_t x32;
  x1 = ((arg1[3]) * 0x3);
  x2 = ((arg1[2]) * 0x3);
  x3 = ((arg1[1]) * 0x3);
  x4 = ((arg1[0]) * 0x3);
  x5 = (x4 >> 48);
  x6 = (x4 & UINT64_C(0xffffffffffff));
  x7 = (x5 + x3);
  x8 = (x1 >> 48);
  x9 = (x1 & UINT64_C(0xffffffffffff));
  x10 = (x8 << 16);
  x11 = (x7 + x10);
  x12 = (x11 >> 48);
  x13 = (x11 & UINT64_C(0xffffffffffff));
  x14 = (x6 + x8);
  x15 = (x12 + x2);
  x16 = (fiat_p192_uint1)(x14 >> 48);
  x17 = (x14 & UINT64_C(0xffffffffffff));
  x18 = (x16 + x13);
  x19 = (x15 >> 48);
  x20 = (x15 & UINT64_C(0xffffffffffff));
  x21 = (x19 + x9);
  x22 = (fiat_p192_uint1)(x21 >> 48);
  x23 = (x21 & UINT64_C(0xffffffffffff));
  x24 = ((uint64_t)x22 << 16);
  x25 = (x18 + x24);
  x26 = (fiat_p192_uint1)(x25 >> 48);
  x27 = (x25 & UINT64_C(0xffffffffffff));
  x28 = (x17 + (uint64_t)x22);
  x29 = (x26 + x20);
  x30 = (fiat_p192_uint1)(x28 >> 48);
  x31 = (x28 & UINT64_C(0xffffffffffff));
  x32 = (x30 + x27);
  out1[0] = x31;
  out1[1] = x32;
  out1[2] = x29;
  out1[3] = x23;
}

/*
 * The function fiat_p192_carry_scmul_4 multiplies a field element by 4 and reduces the result.
 * Postconditions:
 *   eval out1 mod m = (4 * eval arg1) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000]]
 */
static void fiat_p192_carry_scmul_4(uint64_t out1[4], const uint64_t arg1[4]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  uint64_t x9;
  uint64_t x10;
  uint64_t x11;
  uint64_t x12;
  uint64_t x13;
  uint64_t x14;
  uint64_t x15;
  fiat_p192_uint1 x16;
  uint64_t x17;
  uint64_t x18;
  uint64_t x19;
  uint64_t x20;
  uint64_t x21;
  fiat_p192_uint1 x22;
  uint64_t x23;
  uint64_t x24;
  uint64_t x25;
  fiat_p192_uint1 x26;
  uint64_t x27;
  uint64_t x28;
  uint64_t x29;
  fiat_p192_uint1 x30;
  uint64_t x31;
  uint64_t x32;
  x1 = ((arg1[3]) << 2);
  x2 = ((arg1[2]) << 2);
  x3 = ((arg1[1]) << 2);
  x4 = ((arg1[0]) << 2);
  x5 = (x4 >> 48);
  x6 = (x4 & UINT64_C(0xffffffffffff));
  x7 = (x5 + x3);
  x8 = (x1 >> 48);
  x9 = (x1 & UINT64_C(0xffffffffffff));
  x10 = (x8 << 16);
  x11 = (x7 + x10);
  x12 = (x11 >> 48);
  x13 = (x11 & UINT64_C(0xffffffffffff));
  x14 = (x6 + x8);
  x15 = (x12 + x2);
  x16 = (fiat_p192_uint1)(x14 >> 48);
  x17 = (x14 & UINT64_C(0xffffffffffff));
  x18 = (x16 + x13);
  x19 = (x15 >> 48);
  x20 = (x15 & UINT64_C(0xffffffffffff));
  x21 = (x19 + x9);
  x22 = (fiat_p192_uint1)(x21 >> 48);
  x23 = (x21 & UINT64_C(0xffffffffffff));
  x24 = ((uint64_t)x22 << 16);
  x25 = (x18 + x24);
  x26 = (fiat_p192_uint1)(x25 >> 48);
  x27 = (x25 & UINT64_C(0xffffffffffff));
  x28 = (x17 + (uint64_t)x22);
  x29 = (x26 + x20);
  x30 = (fiat_p192_uint1)(x28 >> 48);
  x31 = (x28 & UINT64_C(0xffffffffffff));
  x32 = (x30 + x27);
  out1[0] = x31;
  out1[1] = x32;
  out1[2] = x29;
  out1[3] = x23;
}

/*
 * The function fiat_p192_carry_scmul_8 multiplies a field element by 8 and reduces the result.
 * Postconditions:
 *   eval out1 mod m = (8 * eval arg1) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000], [0x0 ~> 0x3000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000]]
 */
static void fiat_p192_carry_scmul_8(uint64_t out1[4], const uint64_t arg1[4]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  uint64_t x9;
  uint64_t x10;
  uint64_t x11;
  uint64_t x12;
  uint64_t x13;
  uint64_t x14;
  uint64_t x15;
  fiat_p192_uint1 x16;
  uint64_t x17;
  uint64_t x18;
  uint64_t x19;
  uint64_t x20;
  uint64_t x21;
  fiat_p192_uint1 x22;
  uint64_t x23;
  uint64_t x24;
  uint64_t x25;
  fiat_p192_uint1 x26;
  uint64_t x27;
  uint64_t x28;
  uint64_t x29;
  fiat_p192_uint1 x30;
  uint64_t x31;
  uint64_t x32;
  x1 = ((arg1[3]) << 3);
  x2 = ((arg1[2]) << 3);
  x3 = ((arg1[1]) << 3);
  x4 = ((arg1[0]) << 3);
  x5 = (x4 >> 48);
  x6 = (x4 & UINT64_C(0xffffffffffff));
  x7 = (x5 + x3);
  x8 = (x1 >> 48);
  x9 = (x1 & UINT64_C(0xffffffffffff));
  x10 = (x8 << 16);
  x11 = (x7 + x10);
  x12 = (x11 >> 48);
  x13 = (x11 & UINT64_C(0xffffffffffff));
  x14 = (x6 + x8);
  x15 = (x12 + x2);
  x16 = (fiat_p192_uint1)(x14 >> 48);
  x17 = (x14 & UINT64_C(0xffffffffffff));
  x18 = (x16 + x13);
  x19 = (x15 >> 48);
  x20 = (x15 & UINT64_C(0xffffffffffff));
  x21 = (x19 + x9);
  x22 = (fiat_p192_uint1)(x21 >> 48);
  x23 = (x21 & UINT64_C(0xffffffffffff));
  x24 = ((uint64_t)x22 << 16);
  x25 = (x18 + x24);
  x26 = (fiat_p192_uint1)(x25 >> 48);
  x27 = (x25 & UINT64_C(0xffffffffffff));
  x28 = (x17 + (uint64_t)x22);
  x29 = (x26 + x20);
  x30 = (fiat_p192_uint1)(x28 >> 48);
  x31 = (x28 & UINT64_C(0xffffffffffff));
  x32 = (x30 + x27);
  out1[0] = x31;
  out1[1] = x32;
  out1[2] = x29;
  out1[3] = x23;
}

/*
 * The function fiat_p192_selectznz is a multi-limb conditional select.
 * Postconditions:
 *   eval out1 = (if arg1 = 0 then eval arg2 else eval arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
static void fiat_p192_selectznz(uint64_t out1[4], fiat_p192_uint1 arg1, const uint64_t arg2[4], const uint64_t arg3[4]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  fiat_p192_cmovznz_u64(&x1, arg1, (arg2[0]), (arg3[0]));
  fiat_p192_cmovznz_u64(&x2, arg1, (arg2[1]), (arg3[1]));
  fiat_p192_cmovznz_u64(&x3, arg1, (arg2[2]), (arg3[2]));
  fiat_p192_cmovznz_u64(&x4, arg1, (arg2[3]), (arg3[3]));
  out1[0] = x1;
  out1[1] = x2;
  out1[2] = x3;
  out1[3] = x4;
}

/*
 * The function fiat_p192_to_bytes serializes a field element to bytes in little-endian order.
 * Postconditions:
 *   out1 = map (λ x, ⌊((eval arg1 mod m) mod 2^(8 * (x + 1))) / 2^(8 * x)⌋) [0..23]
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]
 */
static void fiat_p192_to_bytes(uint8_t out1[24], const uint64_t arg1[4]) {
  uint64_t x1;
  fiat_p192_uint1 x2;
  uint64_t x3;
  fiat_p192_uint1 x4;
  uint64_t x5;
  fiat_p192_uint1 x6;
  uint64_t x7;
  fiat_p192_uint1 x8;
  uint64_t x9;
  uint64_t x10;
  fiat_p192_uint1 x11;
  uint64_t x12;
  fiat_p192_uint1 x13;
  uint64_t x14;
  fiat_p192_uint1 x15;
  uint64_t x16;
  fiat_p192_uint1 x17;
  uint8_t x18;
  uint64_t x19;
  uint8_t x20;
  uint64_t x21;
  uint8_t x22;
  uint64_t x23;
  uint8_t x24;
  uint64_t x25;
  uint8_t x26;
  uint8_t x27;
  uint8_t x28;
  uint64_t x29;
  uint8_t x30;
  uint64_t x31;
  uint8_t x32;
  uint64_t x33;
  uint8_t x34;
  uint64_t x35;
  uint8_t x36;
  uint8_t x37;
  uint8_t x38;
  uint64_t x39;
  uint8_t x40;
  uint64_t x41;
  uint8_t x42;
  uint64_t x43;
  uint8_t x44;
  uint64_t x45;
  uint8_t x46;
  uint8_t x47;
  uint8_t x48;
  uint64_t x49;
  uint8_t x50;
  uint64_t x51;
  uint8_t x52;
  uint64_t x53;
  uint8_t x54;
  uint64_t x55;
  uint8_t x56;
  uint8_t x57;
  fiat_p192_subborrowx_u48(&x1, &x2, 0x0, (arg1[0]), UINT64_C(0xffffffffffff));
  fiat_p192_subborrowx_u48(&x3, &x4, x2, (arg1[1]), UINT64_C(0xfffffffeffff));
  fiat_p192_subborrowx_u48(&x5, &x6, x4, (arg1[2]), UINT64_C(0xffffffffffff));
  fiat_p192_subborrowx_u48(&x7, &x8, x6, (arg1[3]), UINT64_C(0xffffffffffff));
  fiat_p192_cmovznz_u64(&x9, x8, 0x0, UINT64_C(0xffffffffffffffff));
  fiat_p192_addcarryx_u48(&x10, &x11, 0x0, x1, (x9 & UINT64_C(0xffffffffffff)));
  fiat_p192_addcarryx_u48(&x12, &x13, x11, x3, (x9 & UINT64_C(0xfffffffeffff)));
  fiat_p192_addcarryx_u48(&x14, &x15, x13, x5, (x9 & UINT64_C(0xffffffffffff)));
  fiat_p192_addcarryx_u48(&x16, &x17, x15, x7, (x9 & UINT64_C(0xffffffffffff)));
  x18 = (uint8_t)(x10 & UINT8_C(0xff));
  x19 = (x10 >> 8);
  x20 = (uint8_t)(x19 & UINT8_C(0xff));
  x21 = (x19 >> 8);
  x22 = (uint8_t)(x21 & UINT8_C(0xff));
  x23 = (x21 >> 8);
  x24 = (uint8_t)(x23 & UINT8_C(0xff));
  x25 = (x23 >> 8);
  x26 = (uint8_t)(x25 & UINT8_C(0xff));
  x27 = (uint8_t)(x25 >> 8);
  x28 = (uint8_t)(x12 & UINT8_C(0xff));
  x29 = (x12 >> 8);
  x30 = (uint8_t)(x29 & UINT8_C(0xff));
  x31 = (x29 >> 8);
  x32 = (uint8_t)(x31 & UINT8_C(0xff));
  x33 = (x31 >> 8);
  x34 = (uint8_t)(x33 & UINT8_C(0xff));
  x35 = (x33 >> 8);
  x36 = (uint8_t)(x35 & UINT8_C(0xff));
  x37 = (uint8_t)(x35 >> 8);
  x38 = (uint8_t)(x14 & UINT8_C(0xff));
  x39 = (x14 >> 8);
  x40 = (uint8_t)(x39 & UINT8_C(0xff));
  x41 = (x39 >> 8);
  x42 = (uint8_t)(x41 & UINT8_C(0xff));
  x43 = (x41 >> 8);
  x44 = (uint8_t)(x43 & UINT8_C(0xff));
  x45 = (x43 >> 8);
  x46 = (uint8_t)(x45 & UINT8_C(0xff));
  x47 = (uint8_t)(x45 >> 8);
  x48 = (uint8_t)(x16 & UINT8_C(0xff));
  x49 = (x16 >> 8);
  x50 = (uint8_t)(x49 & UINT8_C(0xff));
  x51 = (x49 >> 8);
  x52 = (uint8_t)(x51 & UINT8_C(0xff));
  x53 = (x51 >> 8);
  x54 = (uint8_t)(x53 & UINT8_C(0xff));
  x55 = (x53 >> 8);
  x56 = (uint8_t)(x55 & UINT8_C(0xff));
  x57 = (uint8_t)(x55 >> 8);
  out1[0] = x18;
  out1[1] = x20;
  out1[2] = x22;
  out1[3] = x24;
  out1[4] = x26;
  out1[5] = x27;
  out1[6] = x28;
  out1[7] = x30;
  out1[8] = x32;
  out1[9] = x34;
  out1[10] = x36;
  out1[11] = x37;
  out1[12] = x38;
  out1[13] = x40;
  out1[14] = x42;
  out1[15] = x44;
  out1[16] = x46;
  out1[17] = x47;
  out1[18] = x48;
  out1[19] = x50;
  out1[20] = x52;
  out1[21] = x54;
  out1[22] = x56;
  out1[23] = x57;
}

/*
 * The function fiat_p192_from_bytes deserializes a field element from bytes in little-endian order.
 * Postconditions:
 *   eval out1 mod m = bytes_eval arg1 mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000], [0x0 ~> 0x1000000000000]]
 */
static void fiat_p192_from_bytes(uint64_t out1[4], const uint8_t arg1[24]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint8_t x6;
  uint64_t x7;
  uint64_t x8;
  uint64_t x9;
  uint64_t x10;
  uint64_t x11;
  uint8_t x12;
  uint64_t x13;
  uint64_t x14;
  uint64_t x15;
  uint64_t x16;
  uint64_t x17;
  uint8_t x18;
  uint64_t x19;
  uint64_t x20;
  uint64_t x21;
  uint64_t x22;
  uint64_t x23;
  uint8_t x24;
  uint64_t x25;
  uint64_t x26;
  uint64_t x27;
  uint64_t x28;
  uint64_t x29;
  uint64_t x30;
  uint64_t x31;
  uint64_t x32;
  uint64_t x33;
  uint64_t x34;
  uint64_t x35;
  uint64_t x36;
  uint64_t x37;
  uint64_t x38;
  uint64_t x39;
  uint64_t x40;
  uint64_t x41;
  uint64_t x42;
  uint64_t x43;
  uint64_t x44;
  x1 = ((uint64_t)(arg1[23]) << 40);
  x2 = ((uint64_t)(arg1[22]) << 32);
  x3 = ((uint64_t)(arg1[21]) << 24);
  x4 = ((uint64_t)(arg1[20]) << 16);
  x5 = ((uint64_t)(arg1[19]) << 8);
  x6 = (arg1[18]);
  x7 = ((uint64_t)(arg1[17]) << 40);
  x8 = ((uint64_t)(arg1[16]) << 32);
  x9 = ((uint64_t)(arg1[15]) << 24);
  x10 = ((uint64_t)(arg1[14]) << 16);
  x11 = ((uint64_t)(arg1[13]) << 8);
  x12 = (arg1[12]);
  x13 = ((uint64_t)(arg1[11]) << 40);
  x14 = ((uint64_t)(arg1[10]) << 32);
  x15 = ((uint64_t)(arg1[9]) << 24);
  x16 = ((uint64_t)(arg1[8]) << 16);
  x17 = ((uint64_t)(arg1[7]) << 8);
  x18 = (arg1[6]);
  x19 = ((uint64_t)(arg1[5]) << 40);
  x20 = ((uint64_t)(arg1[4]) << 32);
  x21 = ((uint64_t)(arg1[3]) << 24);
  x22 = ((uint64_t)(arg1[2]) << 16);
  x23 = ((uint64_t)(arg1[1]) << 8);
  x24 = (arg1[0]);
  x25 = (x23 + (uint64_t)x24);
  x26 = (x22 + x25);
  x27 = (x21 + x26);
  x28 = (x20 + x27);
  x29 = (x19 + x28);
  x30 = (x17 + (uint64_t)x18);
  x31 = (x16 + x30);
  x32 = (x15 + x31);
  x33 = (x14 + x32);
  x34 = (x13 + x33);
  x35 = (x11 + (uint64_t)x12);
  x36 = (x10 + x35);
  x37 = (x9 + x36);
  x38 = (x8 + x37);
  x39 = (x7 + x38);
  x40 = (x5 + (uint64_t)x6);
  x41 = (x4 + x40);
  x42 = (x3 + x41);
  x43 = (x2 + x42);
  x44 = (x1 + x43);
  out1[0] = x29;
  out1[1] = x34;
  out1[2] = x39;
  out1[3] = x44;
}
