/* Autogenerated: /src/ExtractionOCaml/unsaturated_solinas --static p448 64 8 '2^448 - 2^224 - 1' add sub opp carry carry_mul carry_square carry_scmul3 carry_scmul4 carry_scmul8 carry_scmul39082 carry_scmul39081 selectznz to_bytes from_bytes */
/* curve description: p448 */
/* machine_wordsize = 64 (from "64") */
/* requested operations: add, sub, opp, carry, carry_mul, carry_square, carry_scmul3, carry_scmul4, carry_scmul8, carry_scmul39082, carry_scmul39081, selectznz, to_bytes, from_bytes */
/* n = 8 (from "8") */
/* s-c = 2^448 - [(2^224, 1), (1, 1)] (from "2^448 - 2^224 - 1") */
/* tight_bounds_multiplier = 1 (from "") */
/*  */
/* Computed values: */
/* carry_chain = [3, 7, 4, 0, 5, 1, 6, 2, 7, 3, 4, 0] */
/* eval z = z[0] + (z[1] << 56) + (z[2] << 112) + (z[3] << 168) + (z[4] << 224) + (z[5] << 0x118) + (z[6] << 0x150) + (z[7] << 0x188) */
/* bytes_eval z = z[0] + (z[1] << 8) + (z[2] << 16) + (z[3] << 24) + (z[4] << 32) + (z[5] << 40) + (z[6] << 48) + (z[7] << 56) + (z[8] << 64) + (z[9] << 72) + (z[10] << 80) + (z[11] << 88) + (z[12] << 96) + (z[13] << 104) + (z[14] << 112) + (z[15] << 120) + (z[16] << 128) + (z[17] << 136) + (z[18] << 144) + (z[19] << 152) + (z[20] << 160) + (z[21] << 168) + (z[22] << 176) + (z[23] << 184) + (z[24] << 192) + (z[25] << 200) + (z[26] << 208) + (z[27] << 216) + (z[28] << 224) + (z[29] << 232) + (z[30] << 240) + (z[31] << 248) + (z[32] << 256) + (z[33] << 0x108) + (z[34] << 0x110) + (z[35] << 0x118) + (z[36] << 0x120) + (z[37] << 0x128) + (z[38] << 0x130) + (z[39] << 0x138) + (z[40] << 0x140) + (z[41] << 0x148) + (z[42] << 0x150) + (z[43] << 0x158) + (z[44] << 0x160) + (z[45] << 0x168) + (z[46] << 0x170) + (z[47] << 0x178) + (z[48] << 0x180) + (z[49] << 0x188) + (z[50] << 0x190) + (z[51] << 0x198) + (z[52] << 0x1a0) + (z[53] << 0x1a8) + (z[54] << 0x1b0) + (z[55] << 0x1b8) */
/* balance = [0x1fffffffffffffe, 0x1fffffffffffffe, 0x1fffffffffffffe, 0x1fffffffffffffe, 0x1fffffffffffffc, 0x1fffffffffffffe, 0x1fffffffffffffe, 0x1fffffffffffffe] */

#include <stdint.h>
typedef unsigned char fiat_p448_uint1;
typedef signed char fiat_p448_int1;
typedef torsion_int128_t fiat_p448_int128;
typedef torsion_uint128_t fiat_p448_uint128;

#if (-1 & 3) != 3
#error "This code only works on a two's complement system"
#endif


/*
 * The function fiat_p448_addcarryx_u56 is an addition with carry.
 * Postconditions:
 *   out1 = (arg1 + arg2 + arg3) mod 2^56
 *   out2 = ⌊(arg1 + arg2 + arg3) / 2^56⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffff]
 *   out2: [0x0 ~> 0x1]
 */
static void fiat_p448_addcarryx_u56(uint64_t* out1, fiat_p448_uint1* out2, fiat_p448_uint1 arg1, uint64_t arg2, uint64_t arg3) {
  uint64_t x1;
  uint64_t x2;
  fiat_p448_uint1 x3;
  x1 = ((arg1 + arg2) + arg3);
  x2 = (x1 & UINT64_C(0xffffffffffffff));
  x3 = (fiat_p448_uint1)(x1 >> 56);
  *out1 = x2;
  *out2 = x3;
}

/*
 * The function fiat_p448_subborrowx_u56 is a subtraction with borrow.
 * Postconditions:
 *   out1 = (-arg1 + arg2 + -arg3) mod 2^56
 *   out2 = -⌊(-arg1 + arg2 + -arg3) / 2^56⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffff]
 *   out2: [0x0 ~> 0x1]
 */
static void fiat_p448_subborrowx_u56(uint64_t* out1, fiat_p448_uint1* out2, fiat_p448_uint1 arg1, uint64_t arg2, uint64_t arg3) {
  int64_t x1;
  fiat_p448_int1 x2;
  uint64_t x3;
  x1 = ((int64_t)(arg2 - (int64_t)arg1) - (int64_t)arg3);
  x2 = (fiat_p448_int1)(x1 >> 56);
  x3 = (x1 & UINT64_C(0xffffffffffffff));
  *out1 = x3;
  *out2 = (fiat_p448_uint1)(0x0 - x2);
}

/*
 * The function fiat_p448_cmovznz_u64 is a single-word conditional move.
 * Postconditions:
 *   out1 = (if arg1 = 0 then arg2 else arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 */
static void fiat_p448_cmovznz_u64(uint64_t* out1, fiat_p448_uint1 arg1, uint64_t arg2, uint64_t arg3) {
  fiat_p448_uint1 x1;
  uint64_t x2;
  uint64_t x3;
  x1 = (!(!arg1));
  x2 = ((fiat_p448_int1)(0x0 - x1) & UINT64_C(0xffffffffffffffff));
  x3 = ((fe_word_barrier(x2) & arg3) | (fe_word_barrier(~x2) & arg2));
  *out1 = x3;
}

/*
 * The function fiat_p448_add adds two field elements.
 * Postconditions:
 *   eval out1 mod m = (eval arg1 + eval arg2) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000]]
 *   arg2: [[0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000]]
 */
static void fiat_p448_add(uint64_t out1[8], const uint64_t arg1[8], const uint64_t arg2[8]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  x1 = ((arg1[0]) + (arg2[0]));
  x2 = ((arg1[1]) + (arg2[1]));
  x3 = ((arg1[2]) + (arg2[2]));
  x4 = ((arg1[3]) + (arg2[3]));
  x5 = ((arg1[4]) + (arg2[4]));
  x6 = ((arg1[5]) + (arg2[5]));
  x7 = ((arg1[6]) + (arg2[6]));
  x8 = ((arg1[7]) + (arg2[7]));
  out1[0] = x1;
  out1[1] = x2;
  out1[2] = x3;
  out1[3] = x4;
  out1[4] = x5;
  out1[5] = x6;
  out1[6] = x7;
  out1[7] = x8;
}

/*
 * The function fiat_p448_sub subtracts two field elements.
 * Postconditions:
 *   eval out1 mod m = (eval arg1 - eval arg2) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000]]
 *   arg2: [[0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000]]
 */
static void fiat_p448_sub(uint64_t out1[8], const uint64_t arg1[8], const uint64_t arg2[8]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  x1 = ((UINT64_C(0x1fffffffffffffe) + (arg1[0])) - (arg2[0]));
  x2 = ((UINT64_C(0x1fffffffffffffe) + (arg1[1])) - (arg2[1]));
  x3 = ((UINT64_C(0x1fffffffffffffe) + (arg1[2])) - (arg2[2]));
  x4 = ((UINT64_C(0x1fffffffffffffe) + (arg1[3])) - (arg2[3]));
  x5 = ((UINT64_C(0x1fffffffffffffc) + (arg1[4])) - (arg2[4]));
  x6 = ((UINT64_C(0x1fffffffffffffe) + (arg1[5])) - (arg2[5]));
  x7 = ((UINT64_C(0x1fffffffffffffe) + (arg1[6])) - (arg2[6]));
  x8 = ((UINT64_C(0x1fffffffffffffe) + (arg1[7])) - (arg2[7]));
  out1[0] = x1;
  out1[1] = x2;
  out1[2] = x3;
  out1[3] = x4;
  out1[4] = x5;
  out1[5] = x6;
  out1[6] = x7;
  out1[7] = x8;
}

/*
 * The function fiat_p448_opp negates a field element.
 * Postconditions:
 *   eval out1 mod m = -eval arg1 mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000]]
 */
static void fiat_p448_opp(uint64_t out1[8], const uint64_t arg1[8]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  x1 = (UINT64_C(0x1fffffffffffffe) - (arg1[0]));
  x2 = (UINT64_C(0x1fffffffffffffe) - (arg1[1]));
  x3 = (UINT64_C(0x1fffffffffffffe) - (arg1[2]));
  x4 = (UINT64_C(0x1fffffffffffffe) - (arg1[3]));
  x5 = (UINT64_C(0x1fffffffffffffc) - (arg1[4]));
  x6 = (UINT64_C(0x1fffffffffffffe) - (arg1[5]));
  x7 = (UINT64_C(0x1fffffffffffffe) - (arg1[6]));
  x8 = (UINT64_C(0x1fffffffffffffe) - (arg1[7]));
  out1[0] = x1;
  out1[1] = x2;
  out1[2] = x3;
  out1[3] = x4;
  out1[4] = x5;
  out1[5] = x6;
  out1[6] = x7;
  out1[7] = x8;
}

/*
 * The function fiat_p448_carry reduces a field element.
 * Postconditions:
 *   eval out1 mod m = eval arg1 mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000]]
 */
static void fiat_p448_carry(uint64_t out1[8], const uint64_t arg1[8]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  uint64_t x9;
  uint64_t x10;
  uint64_t x11;
  fiat_p448_uint1 x12;
  uint64_t x13;
  uint64_t x14;
  uint64_t x15;
  uint64_t x16;
  uint64_t x17;
  uint64_t x18;
  uint64_t x19;
  uint64_t x20;
  uint64_t x21;
  uint64_t x22;
  x1 = (arg1[3]);
  x2 = (arg1[7]);
  x3 = (x2 >> 56);
  x4 = (((x1 >> 56) + (arg1[4])) + x3);
  x5 = ((arg1[0]) + x3);
  x6 = ((x4 >> 56) + (arg1[5]));
  x7 = ((x5 >> 56) + (arg1[1]));
  x8 = ((x6 >> 56) + (arg1[6]));
  x9 = ((x7 >> 56) + (arg1[2]));
  x10 = ((x8 >> 56) + (x2 & UINT64_C(0xffffffffffffff)));
  x11 = ((x9 >> 56) + (x1 & UINT64_C(0xffffffffffffff)));
  x12 = (fiat_p448_uint1)(x10 >> 56);
  x13 = ((x5 & UINT64_C(0xffffffffffffff)) + (uint64_t)x12);
  x14 = ((fiat_p448_uint1)(x11 >> 56) + ((x4 & UINT64_C(0xffffffffffffff)) + (uint64_t)x12));
  x15 = (x13 & UINT64_C(0xffffffffffffff));
  x16 = ((fiat_p448_uint1)(x13 >> 56) + (x7 & UINT64_C(0xffffffffffffff)));
  x17 = (x9 & UINT64_C(0xffffffffffffff));
  x18 = (x11 & UINT64_C(0xffffffffffffff));
  x19 = (x14 & UINT64_C(0xffffffffffffff));
  x20 = ((fiat_p448_uint1)(x14 >> 56) + (x6 & UINT64_C(0xffffffffffffff)));
  x21 = (x8 & UINT64_C(0xffffffffffffff));
  x22 = (x10 & UINT64_C(0xffffffffffffff));
  out1[0] = x15;
  out1[1] = x16;
  out1[2] = x17;
  out1[3] = x18;
  out1[4] = x19;
  out1[5] = x20;
  out1[6] = x21;
  out1[7] = x22;
}

/*
 * The function fiat_p448_carry_mul multiplies two field elements and reduces the result.
 * Postconditions:
 *   eval out1 mod m = (eval arg1 * eval arg2) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000]]
 *   arg2: [[0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000]]
 */
static void fiat_p448_carry_mul(uint64_t out1[8], const uint64_t arg1[8], const uint64_t arg2[8]) {
  fiat_p448_uint128 x1;
  fiat_p448_uint128 x2;
  fiat_p448_uint128 x3;
  fiat_p448_uint128 x4;
  fiat_p448_uint128 x5;
  fiat_p448_uint128 x6;
  fiat_p448_uint128 x7;
  fiat_p448_uint128 x8;
  fiat_p448_uint128 x9;
  fiat_p448_uint128 x10;
  fiat_p448_uint128 x11;
  fiat_p448_uint128 x12;
  fiat_p448_uint128 x13;
  fiat_p448_uint128 x14;
  fiat_p448_uint128 x15;
  fiat_p448_uint128 x16;
  fiat_p448_uint128 x17;
  fiat_p448_uint128 x18;
  fiat_p448_uint128 x19;
  fiat_p448_uint128 x20;
  fiat_p448_uint128 x21;
  fiat_p448_uint128 x22;
  fiat_p448_uint128 x23;
  fiat_p448_uint128 x24;
  fiat_p448_uint128 x25;
  fiat_p448_uint128 x26;
  fiat_p448_uint128 x27;
  fiat_p448_uint128 x28;
  fiat_p448_uint128 x29;
  fiat_p448_uint128 x30;
  fiat_p448_uint128 x31;
  fiat_p448_uint128 x32;
  fiat_p448_uint128 x33;
  fiat_p448_uint128 x34;
  fiat_p448_uint128 x35;
  fiat_p448_uint128 x36;
  fiat_p448_uint128 x37;
  fiat_p448_uint128 x38;
  fiat_p448_uint128 x39;
  fiat_p448_uint128 x40;
  fiat_p448_uint128 x41;
  fiat_p448_uint128 x42;
  fiat_p448_uint128 x43;
  fiat_p448_uint128 x44;
  fiat_p448_uint128 x45;
  fiat_p448_uint128 x46;
  fiat_p448_uint128 x47;
  fiat_p448_uint128 x48;
  fiat_p448_uint128 x49;
  fiat_p448_uint128 x50;
  fiat_p448_uint128 x51;
  fiat_p448_uint128 x52;
  fiat_p448_uint128 x53;
  fiat_p448_uint128 x54;
  fiat_p448_uint128 x55;
  fiat_p448_uint128 x56;
  fiat_p448_uint128 x57;
  fiat_p448_uint128 x58;
  fiat_p448_uint128 x59;
  fiat_p448_uint128 x60;
  fiat_p448_uint128 x61;
  fiat_p448_uint128 x62;
  fiat_p448_uint128 x63;
  fiat_p448_uint128 x64;
  fiat_p448_uint128 x65;
  fiat_p448_uint128 x66;
  fiat_p448_uint128 x67;
  fiat_p448_uint128 x68;
  fiat_p448_uint128 x69;
  fiat_p448_uint128 x70;
  fiat_p448_uint128 x71;
  fiat_p448_uint128 x72;
  fiat_p448_uint128 x73;
  fiat_p448_uint128 x74;
  fiat_p448_uint128 x75;
  fiat_p448_uint128 x76;
  fiat_p448_uint128 x77;
  fiat_p448_uint128 x78;
  fiat_p448_uint128 x79;
  fiat_p448_uint128 x80;
  fiat_p448_uint128 x81;
  fiat_p448_uint128 x82;
  fiat_p448_uint128 x83;
  fiat_p448_uint128 x84;
  fiat_p448_uint128 x85;
  fiat_p448_uint128 x86;
  fiat_p448_uint128 x87;
  fiat_p448_uint128 x88;
  fiat_p448_uint128 x89;
  fiat_p448_uint128 x90;
  fiat_p448_uint128 x91;
  fiat_p448_uint128 x92;
  fiat_p448_uint128 x93;
  fiat_p448_uint128 x94;
  fiat_p448_uint128 x95;
  fiat_p448_uint128 x96;
  fiat_p448_uint128 x97;
  fiat_p448_uint128 x98;
  fiat_p448_uint128 x99;
  uint64_t x100;
  uint64_t x101;
  fiat_p448_uint128 x102;
  fiat_p448_uint128 x103;
  fiat_p448_uint128 x104;
  fiat_p448_uint128 x105;
  fiat_p448_uint128 x106;
  fiat_p448_uint128 x107;
  fiat_p448_uint128 x108;
  fiat_p448_uint128 x109;
  uint64_t x110;
  uint64_t x111;
  fiat_p448_uint128 x112;
  uint64_t x113;
  uint64_t x114;
  fiat_p448_uint128 x115;
  fiat_p448_uint128 x116;
  uint64_t x117;
  uint64_t x118;
  fiat_p448_uint128 x119;
  uint64_t x120;
  uint64_t x121;
  fiat_p448_uint128 x122;
  uint64_t x123;
  uint64_t x124;
  fiat_p448_uint128 x125;
  uint64_t x126;
  uint64_t x127;
  uint64_t x128;
  uint64_t x129;
  uint64_t x130;
  uint64_t x131;
  uint64_t x132;
  uint64_t x133;
  uint64_t x134;
  uint64_t x135;
  uint64_t x136;
  uint64_t x137;
  uint64_t x138;
  fiat_p448_uint1 x139;
  uint64_t x140;
  uint64_t x141;
  fiat_p448_uint1 x142;
  uint64_t x143;
  uint64_t x144;
  x1 = ((fiat_p448_uint128)(arg1[7]) * (arg2[7]));
  x2 = ((fiat_p448_uint128)(arg1[7]) * (arg2[6]));
  x3 = ((fiat_p448_uint128)(arg1[7]) * (arg2[5]));
  x4 = ((fiat_p448_uint128)(arg1[6]) * (arg2[7]));
  x5 = ((fiat_p448_uint128)(arg1[6]) * (arg2[6]));
  x6 = ((fiat_p448_uint128)(arg1[5]) * (arg2[7]));
  x7 = ((fiat_p448_uint128)(arg1[7]) * (arg2[7]));
  x8 = ((fiat_p448_uint128)(arg1[7]) * (arg2[6]));
  x9 = ((fiat_p448_uint128)(arg1[7]) * (arg2[5]));
  x10 = ((fiat_p448_uint128)(arg1[6]) * (arg2[7]));
  x11 = ((fiat_p448_uint128)(arg1[6]) * (arg2[6]));
  x12 = ((fiat_p448_uint128)(arg1[5]) * (arg2[7]));
  x13 = ((fiat_p448_uint128)(arg1[7]) * (arg2[7]));
  x14 = ((fiat_p448_uint128)(arg1[7]) * (arg2[6]));
  x15 = ((fiat_p448_uint128)(arg1[7]) * (arg2[5]));
  x16 = ((fiat_p448_uint128)(arg1[7]) * (arg2[4]));
  x17 = ((fiat_p448_uint128)(arg1[7]) * (arg2[3]));
  x18 = ((fiat_p448_uint128)(arg1[7]) * (arg2[2]));
  x19 = ((fiat_p448_uint128)(arg1[7]) * (arg2[1]));
  x20 = ((fiat_p448_uint128)(arg1[6]) * (arg2[7]));
  x21 = ((fiat_p448_uint128)(arg1[6]) * (arg2[6]));
  x22 = ((fiat_p448_uint128)(arg1[6]) * (arg2[5]));
  x23 = ((fiat_p448_uint128)(arg1[6]) * (arg2[4]));
  x24 = ((fiat_p448_uint128)(arg1[6]) * (arg2[3]));
  x25 = ((fiat_p448_uint128)(arg1[6]) * (arg2[2]));
  x26 = ((fiat_p448_uint128)(arg1[5]) * (arg2[7]));
  x27 = ((fiat_p448_uint128)(arg1[5]) * (arg2[6]));
  x28 = ((fiat_p448_uint128)(arg1[5]) * (arg2[5]));
  x29 = ((fiat_p448_uint128)(arg1[5]) * (arg2[4]));
  x30 = ((fiat_p448_uint128)(arg1[5]) * (arg2[3]));
  x31 = ((fiat_p448_uint128)(arg1[4]) * (arg2[7]));
  x32 = ((fiat_p448_uint128)(arg1[4]) * (arg2[6]));
  x33 = ((fiat_p448_uint128)(arg1[4]) * (arg2[5]));
  x34 = ((fiat_p448_uint128)(arg1[4]) * (arg2[4]));
  x35 = ((fiat_p448_uint128)(arg1[3]) * (arg2[7]));
  x36 = ((fiat_p448_uint128)(arg1[3]) * (arg2[6]));
  x37 = ((fiat_p448_uint128)(arg1[3]) * (arg2[5]));
  x38 = ((fiat_p448_uint128)(arg1[2]) * (arg2[7]));
  x39 = ((fiat_p448_uint128)(arg1[2]) * (arg2[6]));
  x40 = ((fiat_p448_uint128)(arg1[1]) * (arg2[7]));
  x41 = ((fiat_p448_uint128)(arg1[7]) * (arg2[4]));
  x42 = ((fiat_p448_uint128)(arg1[7]) * (arg2[3]));
  x43 = ((fiat_p448_uint128)(arg1[7]) * (arg2[2]));
  x44 = ((fiat_p448_uint128)(arg1[7]) * (arg2[1]));
  x45 = ((fiat_p448_uint128)(arg1[6]) * (arg2[5]));
  x46 = ((fiat_p448_uint128)(arg1[6]) * (arg2[4]));
  x47 = ((fiat_p448_uint128)(arg1[6]) * (arg2[3]));
  x48 = ((fiat_p448_uint128)(arg1[6]) * (arg2[2]));
  x49 = ((fiat_p448_uint128)(arg1[5]) * (arg2[6]));
  x50 = ((fiat_p448_uint128)(arg1[5]) * (arg2[5]));
  x51 = ((fiat_p448_uint128)(arg1[5]) * (arg2[4]));
  x52 = ((fiat_p448_uint128)(arg1[5]) * (arg2[3]));
  x53 = ((fiat_p448_uint128)(arg1[4]) * (arg2[7]));
  x54 = ((fiat_p448_uint128)(arg1[4]) * (arg2[6]));
  x55 = ((fiat_p448_uint128)(arg1[4]) * (arg2[5]));
  x56 = ((fiat_p448_uint128)(arg1[4]) * (arg2[4]));
  x57 = ((fiat_p448_uint128)(arg1[3]) * (arg2[7]));
  x58 = ((fiat_p448_uint128)(arg1[3]) * (arg2[6]));
  x59 = ((fiat_p448_uint128)(arg1[3]) * (arg2[5]));
  x60 = ((fiat_p448_uint128)(arg1[2]) * (arg2[7]));
  x61 = ((fiat_p448_uint128)(arg1[2]) * (arg2[6]));
  x62 = ((fiat_p448_uint128)(arg1[1]) * (arg2[7]));
  x63 = ((fiat_p448_uint128)(arg1[7]) * (arg2[0]));
  x64 = ((fiat_p448_uint128)(arg1[6]) * (arg2[1]));
  x65 = ((fiat_p448_uint128)(arg1[6]) * (arg2[0]));
  x66 = ((fiat_p448_uint128)(arg1[5]) * (arg2[2]));
  x67 = ((fiat_p448_uint128)(arg1[5]) * (arg2[1]));
  x68 = ((fiat_p448_uint128)(arg1[5]) * (arg2[0]));
  x69 = ((fiat_p448_uint128)(arg1[4]) * (arg2[3]));
  x70 = ((fiat_p448_uint128)(arg1[4]) * (arg2[2]));
  x71 = ((fiat_p448_uint128)(arg1[4]) * (arg2[1]));
  x72 = ((fiat_p448_uint128)(arg1[4]) * (arg2[0]));
  x73 = ((fiat_p448_uint128)(arg1[3]) * (arg2[4]));
  x74 = ((fiat_p448_uint128)(arg1[3]) * (arg2[3]));
  x75 = ((fiat_p448_uint128)(arg1[3]) * (arg2[2]));
  x76 = ((fiat_p448_uint128)(arg1[3]) * (arg2[1]));
  x77 = ((fiat_p448_uint128)(arg1[3]) * (arg2[0]));
  x78 = ((fiat_p448_uint128)(arg1[2]) * (arg2[5]));
  x79 = ((fiat_p448_uint128)(arg1[2]) * (arg2[4]));
  x80 = ((fiat_p448_uint128)(arg1[2]) * (arg2[3]));
  x81 = ((fiat_p448_uint128)(arg1[2]) * (arg2[2]));
  x82 = ((fiat_p448_uint128)(arg1[2]) * (arg2[1]));
  x83 = ((fiat_p448_uint128)(arg1[2]) * (arg2[0]));
  x84 = ((fiat_p448_uint128)(arg1[1]) * (arg2[6]));
  x85 = ((fiat_p448_uint128)(arg1[1]) * (arg2[5]));
  x86 = ((fiat_p448_uint128)(arg1[1]) * (arg2[4]));
  x87 = ((fiat_p448_uint128)(arg1[1]) * (arg2[3]));
  x88 = ((fiat_p448_uint128)(arg1[1]) * (arg2[2]));
  x89 = ((fiat_p448_uint128)(arg1[1]) * (arg2[1]));
  x90 = ((fiat_p448_uint128)(arg1[1]) * (arg2[0]));
  x91 = ((fiat_p448_uint128)(arg1[0]) * (arg2[7]));
  x92 = ((fiat_p448_uint128)(arg1[0]) * (arg2[6]));
  x93 = ((fiat_p448_uint128)(arg1[0]) * (arg2[5]));
  x94 = ((fiat_p448_uint128)(arg1[0]) * (arg2[4]));
  x95 = ((fiat_p448_uint128)(arg1[0]) * (arg2[3]));
  x96 = ((fiat_p448_uint128)(arg1[0]) * (arg2[2]));
  x97 = ((fiat_p448_uint128)(arg1[0]) * (arg2[1]));
  x98 = ((fiat_p448_uint128)(arg1[0]) * (arg2[0]));
  x99 = (x95 + (x88 + (x82 + (x77 + (x31 + (x27 + (x22 + x16)))))));
  x100 = (uint64_t)(x99 >> 56);
  x101 = (uint64_t)(x99 & UINT64_C(0xffffffffffffff));
  x102 = (x91 + (x84 + (x78 + (x73 + (x69 + (x66 + (x64 + (x63 + (x53 + (x49 + (x45 + x41)))))))))));
  x103 = (x92 + (x85 + (x79 + (x74 + (x70 + (x67 + (x65 + (x57 + (x54 + (x50 + (x46 + (x42 + (x13 + x7)))))))))))));
  x104 = (x93 + (x86 + (x80 + (x75 + (x71 + (x68 + (x60 + (x58 + (x55 + (x51 + (x47 + (x43 + (x20 + (x14 + (x10 + x8)))))))))))))));
  x105 = (x94 + (x87 + (x81 + (x76 + (x72 + (x62 + (x61 + (x59 + (x56 + (x52 + (x48 + (x44 + (x26 + (x21 + (x15 + (x12 + (x11 + x9)))))))))))))))));
  x106 = (x96 + (x89 + (x83 + (x35 + (x32 + (x28 + (x23 + (x17 + x1))))))));
  x107 = (x97 + (x90 + (x38 + (x36 + (x33 + (x29 + (x24 + (x18 + (x4 + x2)))))))));
  x108 = (x98 + (x40 + (x39 + (x37 + (x34 + (x30 + (x25 + (x19 + (x6 + (x5 + x3))))))))));
  x109 = (x100 + x105);
  x110 = (uint64_t)(x102 >> 56);
  x111 = (uint64_t)(x102 & UINT64_C(0xffffffffffffff));
  x112 = (x109 + x110);
  x113 = (uint64_t)(x112 >> 56);
  x114 = (uint64_t)(x112 & UINT64_C(0xffffffffffffff));
  x115 = (x108 + x110);
  x116 = (x113 + x104);
  x117 = (uint64_t)(x115 >> 56);
  x118 = (uint64_t)(x115 & UINT64_C(0xffffffffffffff));
  x119 = (x117 + x107);
  x120 = (uint64_t)(x116 >> 56);
  x121 = (uint64_t)(x116 & UINT64_C(0xffffffffffffff));
  x122 = (x120 + x103);
  x123 = (uint64_t)(x119 >> 56);
  x124 = (uint64_t)(x119 & UINT64_C(0xffffffffffffff));
  x125 = (x123 + x106);
  x126 = (uint64_t)(x122 >> 56);
  x127 = (uint64_t)(x122 & UINT64_C(0xffffffffffffff));
  x128 = (x126 + x111);
  x129 = (uint64_t)(x125 >> 56);
  x130 = (uint64_t)(x125 & UINT64_C(0xffffffffffffff));
  x131 = (x129 + x101);
  x132 = (x128 >> 56);
  x133 = (x128 & UINT64_C(0xffffffffffffff));
  x134 = (x131 >> 56);
  x135 = (x131 & UINT64_C(0xffffffffffffff));
  x136 = (x114 + x132);
  x137 = (x118 + x132);
  x138 = (x134 + x136);
  x139 = (fiat_p448_uint1)(x138 >> 56);
  x140 = (x138 & UINT64_C(0xffffffffffffff));
  x141 = (x139 + x121);
  x142 = (fiat_p448_uint1)(x137 >> 56);
  x143 = (x137 & UINT64_C(0xffffffffffffff));
  x144 = (x142 + x124);
  out1[0] = x143;
  out1[1] = x144;
  out1[2] = x130;
  out1[3] = x135;
  out1[4] = x140;
  out1[5] = x141;
  out1[6] = x127;
  out1[7] = x133;
}

/*
 * The function fiat_p448_carry_square squares a field element and reduces the result.
 * Postconditions:
 *   eval out1 mod m = (eval arg1 * eval arg1) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000]]
 */
static void fiat_p448_carry_square(uint64_t out1[8], const uint64_t arg1[8]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  uint64_t x9;
  uint64_t x10;
  uint64_t x11;
  uint64_t x12;
  uint64_t x13;
  uint64_t x14;
  uint64_t x15;
  uint64_t x16;
  uint64_t x17;
  uint64_t x18;
  uint64_t x19;
  uint64_t x20;
  uint64_t x21;
  fiat_p448_uint128 x22;
  fiat_p448_uint128 x23;
  fiat_p448_uint128 x24;
  fiat_p448_uint128 x25;
  fiat_p448_uint128 x26;
  fiat_p448_uint128 x27;
  fiat_p448_uint128 x28;
  fiat_p448_uint128 x29;
  fiat_p448_uint128 x30;
  fiat_p448_uint128 x31;
  fiat_p448_uint128 x32;
  fiat_p448_uint128 x33;
  fiat_p448_uint128 x34;
  fiat_p448_uint128 x35;
  fiat_p448_uint128 x36;
  fiat_p448_uint128 x37;
  fiat_p448_uint128 x38;
  fiat_p448_uint128 x39;
  fiat_p448_uint128 x40;
  fiat_p448_uint128 x41;
  fiat_p448_uint128 x42;
  fiat_p448_uint128 x43;
  fiat_p448_uint128 x44;
  fiat_p448_uint128 x45;
  fiat_p448_uint128 x46;
  fiat_p448_uint128 x47;
  fiat_p448_uint128 x48;
  fiat_p448_uint128 x49;
  fiat_p448_uint128 x50;
  fiat_p448_uint128 x51;
  fiat_p448_uint128 x52;
  fiat_p448_uint128 x53;
  fiat_p448_uint128 x54;
  fiat_p448_uint128 x55;
  fiat_p448_uint128 x56;
  fiat_p448_uint128 x57;
  fiat_p448_uint128 x58;
  fiat_p448_uint128 x59;
  fiat_p448_uint128 x60;
  fiat_p448_uint128 x61;
  fiat_p448_uint128 x62;
  fiat_p448_uint128 x63;
  fiat_p448_uint128 x64;
  fiat_p448_uint128 x65;
  fiat_p448_uint128 x66;
  fiat_p448_uint128 x67;
  fiat_p448_uint128 x68;
  fiat_p448_uint128 x69;
  fiat_p448_uint128 x70;
  fiat_p448_uint128 x71;
  fiat_p448_uint128 x72;
  fiat_p448_uint128 x73;
  fiat_p448_uint128 x74;
  fiat_p448_uint128 x75;
  fiat_p448_uint128 x76;
  fiat_p448_uint128 x77;
  fiat_p448_uint128 x78;
  uint64_t x79;
  uint64_t x80;
  fiat_p448_uint128 x81;
  fiat_p448_uint128 x82;
  fiat_p448_uint128 x83;
  fiat_p448_uint128 x84;
  fiat_p448_uint128 x85;
  fiat_p448_uint128 x86;
  fiat_p448_uint128 x87;
  fiat_p448_uint128 x88;
  uint64_t x89;
  uint64_t x90;
  fiat_p448_uint128 x91;
  uint64_t x92;
  uint64_t x93;
  fiat_p448_uint128 x94;
  fiat_p448_uint128 x95;
  uint64_t x96;
  uint64_t x97;
  fiat_p448_uint128 x98;
  uint64_t x99;
  uint64_t x100;
  fiat_p448_uint128 x101;
  uint64_t x102;
  uint64_t x103;
  fiat_p448_uint128 x104;
  uint64_t x105;
  uint64_t x106;
  uint64_t x107;
  uint64_t x108;
  uint64_t x109;
  uint64_t x110;
  uint64_t x111;
  uint64_t x112;
  uint64_t x113;
  uint64_t x114;
  uint64_t x115;
  uint64_t x116;
  uint64_t x117;
  fiat_p448_uint1 x118;
  uint64_t x119;
  uint64_t x120;
  fiat_p448_uint1 x121;
  uint64_t x122;
  uint64_t x123;
  x1 = (arg1[7]);
  x2 = (arg1[7]);
  x3 = (x1 * 0x2);
  x4 = (x2 * 0x2);
  x5 = ((arg1[7]) * 0x2);
  x6 = (arg1[6]);
  x7 = (arg1[6]);
  x8 = (x6 * 0x2);
  x9 = (x7 * 0x2);
  x10 = ((arg1[6]) * 0x2);
  x11 = (arg1[5]);
  x12 = (arg1[5]);
  x13 = (x11 * 0x2);
  x14 = (x12 * 0x2);
  x15 = ((arg1[5]) * 0x2);
  x16 = (arg1[4]);
  x17 = (arg1[4]);
  x18 = ((arg1[4]) * 0x2);
  x19 = ((arg1[3]) * 0x2);
  x20 = ((arg1[2]) * 0x2);
  x21 = ((arg1[1]) * 0x2);
  x22 = ((fiat_p448_uint128)(arg1[7]) * x1);
  x23 = ((fiat_p448_uint128)(arg1[6]) * x3);
  x24 = ((fiat_p448_uint128)(arg1[6]) * x6);
  x25 = ((fiat_p448_uint128)(arg1[5]) * x3);
  x26 = ((fiat_p448_uint128)(arg1[7]) * x1);
  x27 = ((fiat_p448_uint128)(arg1[6]) * x3);
  x28 = ((fiat_p448_uint128)(arg1[6]) * x6);
  x29 = ((fiat_p448_uint128)(arg1[5]) * x3);
  x30 = ((fiat_p448_uint128)(arg1[7]) * x2);
  x31 = ((fiat_p448_uint128)(arg1[6]) * x4);
  x32 = ((fiat_p448_uint128)(arg1[6]) * x7);
  x33 = ((fiat_p448_uint128)(arg1[5]) * x4);
  x34 = ((fiat_p448_uint128)(arg1[5]) * x9);
  x35 = ((fiat_p448_uint128)(arg1[5]) * x8);
  x36 = ((fiat_p448_uint128)(arg1[5]) * x12);
  x37 = ((fiat_p448_uint128)(arg1[5]) * x11);
  x38 = ((fiat_p448_uint128)(arg1[4]) * x4);
  x39 = ((fiat_p448_uint128)(arg1[4]) * x3);
  x40 = ((fiat_p448_uint128)(arg1[4]) * x9);
  x41 = ((fiat_p448_uint128)(arg1[4]) * x8);
  x42 = ((fiat_p448_uint128)(arg1[4]) * x14);
  x43 = ((fiat_p448_uint128)(arg1[4]) * x13);
  x44 = ((fiat_p448_uint128)(arg1[4]) * x17);
  x45 = ((fiat_p448_uint128)(arg1[4]) * x16);
  x46 = ((fiat_p448_uint128)(arg1[3]) * x4);
  x47 = ((fiat_p448_uint128)(arg1[3]) * x3);
  x48 = ((fiat_p448_uint128)(arg1[3]) * x9);
  x49 = ((fiat_p448_uint128)(arg1[3]) * x8);
  x50 = ((fiat_p448_uint128)(arg1[3]) * x14);
  x51 = ((fiat_p448_uint128)(arg1[3]) * x13);
  x52 = ((fiat_p448_uint128)(arg1[3]) * x18);
  x53 = ((fiat_p448_uint128)(arg1[3]) * (arg1[3]));
  x54 = ((fiat_p448_uint128)(arg1[2]) * x4);
  x55 = ((fiat_p448_uint128)(arg1[2]) * x3);
  x56 = ((fiat_p448_uint128)(arg1[2]) * x9);
  x57 = ((fiat_p448_uint128)(arg1[2]) * x8);
  x58 = ((fiat_p448_uint128)(arg1[2]) * x15);
  x59 = ((fiat_p448_uint128)(arg1[2]) * x18);
  x60 = ((fiat_p448_uint128)(arg1[2]) * x19);
  x61 = ((fiat_p448_uint128)(arg1[2]) * (arg1[2]));
  x62 = ((fiat_p448_uint128)(arg1[1]) * x4);
  x63 = ((fiat_p448_uint128)(arg1[1]) * x3);
  x64 = ((fiat_p448_uint128)(arg1[1]) * x10);
  x65 = ((fiat_p448_uint128)(arg1[1]) * x15);
  x66 = ((fiat_p448_uint128)(arg1[1]) * x18);
  x67 = ((fiat_p448_uint128)(arg1[1]) * x19);
  x68 = ((fiat_p448_uint128)(arg1[1]) * x20);
  x69 = ((fiat_p448_uint128)(arg1[1]) * (arg1[1]));
  x70 = ((fiat_p448_uint128)(arg1[0]) * x5);
  x71 = ((fiat_p448_uint128)(arg1[0]) * x10);
  x72 = ((fiat_p448_uint128)(arg1[0]) * x15);
  x73 = ((fiat_p448_uint128)(arg1[0]) * x18);
  x74 = ((fiat_p448_uint128)(arg1[0]) * x19);
  x75 = ((fiat_p448_uint128)(arg1[0]) * x20);
  x76 = ((fiat_p448_uint128)(arg1[0]) * x21);
  x77 = ((fiat_p448_uint128)(arg1[0]) * (arg1[0]));
  x78 = (x74 + (x68 + (x38 + x34)));
  x79 = (uint64_t)(x78 >> 56);
  x80 = (uint64_t)(x78 & UINT64_C(0xffffffffffffff));
  x81 = (x70 + (x64 + (x58 + (x52 + (x39 + x35)))));
  x82 = (x71 + (x65 + (x59 + (x53 + (x47 + (x41 + (x37 + (x30 + x26))))))));
  x83 = (x72 + (x66 + (x60 + (x55 + (x49 + (x43 + (x31 + x27)))))));
  x84 = (x73 + (x67 + (x63 + (x61 + (x57 + (x51 + (x45 + (x33 + (x32 + (x29 + x28))))))))));
  x85 = (x75 + (x69 + (x46 + (x40 + (x36 + x22)))));
  x86 = (x76 + (x54 + (x48 + (x42 + x23))));
  x87 = (x77 + (x62 + (x56 + (x50 + (x44 + (x25 + x24))))));
  x88 = (x79 + x84);
  x89 = (uint64_t)(x81 >> 56);
  x90 = (uint64_t)(x81 & UINT64_C(0xffffffffffffff));
  x91 = (x88 + x89);
  x92 = (uint64_t)(x91 >> 56);
  x93 = (uint64_t)(x91 & UINT64_C(0xffffffffffffff));
  x94 = (x87 + x89);
  x95 = (x92 + x83);
  x96 = (uint64_t)(x94 >> 56);
  x97 = (uint64_t)(x94 & UINT64_C(0xffffffffffffff));
  x98 = (x96 + x86);
  x99 = (uint64_t)(x95 >> 56);
  x100 = (uint64_t)(x95 & UINT64_C(0xffffffffffffff));
  x101 = (x99 + x82);
  x102 = (uint64_t)(x98 >> 56);
  x103 = (uint64_t)(x98 & UINT64_C(0xffffffffffffff));
  x104 = (x102 + x85);
  x105 = (uint64_t)(x101 >> 56);
  x106 = (uint64_t)(x101 & UINT64_C(0xffffffffffffff));
  x107 = (x105 + x90);
  x108 = (uint64_t)(x104 >> 56);
  x109 = (uint64_t)(x104 & UINT64_C(0xffffffffffffff));
  x110 = (x108 + x80);
  x111 = (x107 >> 56);
  x112 = (x107 & UINT64_C(0xffffffffffffff));
  x113 = (x110 >> 56);
  x114 = (x110 & UINT64_C(0xffffffffffffff));
  x115 = (x93 + x111);
  x116 = (x97 + x111);
  x117 = (x113 + x115);
  x118 = (fiat_p448_uint1)(x117 >> 56);
  x119 = (x117 & UINT64_C(0xffffffffffffff));
  x120 = (x118 + x100);
  x121 = (fiat_p448_uint1)(x116 >> 56);
  x122 = (x116 & UINT64_C(0xffffffffffffff));
  x123 = (x121 + x103);
  out1[0] = x122;
  out1[1] = x123;
  out1[2] = x109;
  out1[3] = x114;
  out1[4] = x119;
  out1[5] = x120;
  out1[6] = x106;
  out1[7] = x112;
}

/*
 * The function fiat_p448_carry_scmul_3 multiplies a field element by 3 and reduces the result.
 * Postconditions:
 *   eval out1 mod m = (3 * eval arg1) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000]]
 */
static void fiat_p448_carry_scmul_3(uint64_t out1[8], const uint64_t arg1[8]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  uint64_t x9;
  uint64_t x10;
  uint64_t x11;
  uint64_t x12;
  uint64_t x13;
  uint64_t x14;
  uint64_t x15;
  uint64_t x16;
  uint64_t x17;
  uint64_t x18;
  uint64_t x19;
  uint64_t x20;
  uint64_t x21;
  uint64_t x22;
  uint64_t x23;
  uint64_t x24;
  uint64_t x25;
  uint64_t x26;
  uint64_t x27;
  uint64_t x28;
  uint64_t x29;
  uint64_t x30;
  uint64_t x31;
  uint64_t x32;
  uint64_t x33;
  fiat_p448_uint1 x34;
  uint64_t x35;
  fiat_p448_uint1 x36;
  uint64_t x37;
  uint64_t x38;
  uint64_t x39;
  uint64_t x40;
  fiat_p448_uint1 x41;
  uint64_t x42;
  uint64_t x43;
  fiat_p448_uint1 x44;
  uint64_t x45;
  uint64_t x46;
  x1 = ((arg1[7]) * 0x3);
  x2 = ((arg1[6]) * 0x3);
  x3 = ((arg1[5]) * 0x3);
  x4 = ((arg1[4]) * 0x3);
  x5 = ((arg1[3]) * 0x3);
  x6 = ((arg1[2]) * 0x3);
  x7 = ((arg1[1]) * 0x3);
  x8 = ((arg1[0]) * 0x3);
  x9 = (x5 >> 56);
  x10 = (x5 & UINT64_C(0xffffffffffffff));
  x11 = (x9 + x4);
  x12 = (x1 >> 56);
  x13 = (x1 & UINT64_C(0xffffffffffffff));
  x14 = (x11 + x12);
  x15 = (x14 >> 56);
  x16 = (x14 & UINT64_C(0xffffffffffffff));
  x17 = (x8 + x12);
  x18 = (x15 + x3);
  x19 = (x17 >> 56);
  x20 = (x17 & UINT64_C(0xffffffffffffff));
  x21 = (x19 + x7);
  x22 = (x18 >> 56);
  x23 = (x18 & UINT64_C(0xffffffffffffff));
  x24 = (x22 + x2);
  x25 = (x21 >> 56);
  x26 = (x21 & UINT64_C(0xffffffffffffff));
  x27 = (x25 + x6);
  x28 = (x24 >> 56);
  x29 = (x24 & UINT64_C(0xffffffffffffff));
  x30 = (x28 + x13);
  x31 = (x27 >> 56);
  x32 = (x27 & UINT64_C(0xffffffffffffff));
  x33 = (x31 + x10);
  x34 = (fiat_p448_uint1)(x30 >> 56);
  x35 = (x30 & UINT64_C(0xffffffffffffff));
  x36 = (fiat_p448_uint1)(x33 >> 56);
  x37 = (x33 & UINT64_C(0xffffffffffffff));
  x38 = (x16 + (uint64_t)x34);
  x39 = (x20 + (uint64_t)x34);
  x40 = (x36 + x38);
  x41 = (fiat_p448_uint1)(x40 >> 56);
  x42 = (x40 & UINT64_C(0xffffffffffffff));
  x43 = (x41 + x23);
  x44 = (fiat_p448_uint1)(x39 >> 56);
  x45 = (x39 & UINT64_C(0xffffffffffffff));
  x46 = (x44 + x26);
  out1[0] = x45;
  out1[1] = x46;
  out1[2] = x32;
  out1[3] = x37;
  out1[4] = x42;
  out1[5] = x43;
  out1[6] = x29;
  out1[7] = x35;
}

/*
 * The function fiat_p448_carry_scmul_4 multiplies a field element by 4 and reduces the result.
 * Postconditions:
 *   eval out1 mod m = (4 * eval arg1) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000]]
 */
static void fiat_p448_carry_scmul_4(uint64_t out1[8], const uint64_t arg1[8]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  uint64_t x9;
  uint64_t x10;
  uint64_t x11;
  uint64_t x12;
  uint64_t x13;
  uint64_t x14;
  uint64_t x15;
  uint64_t x16;
  uint64_t x17;
  uint64_t x18;
  uint64_t x19;
  uint64_t x20;
  uint64_t x21;
  uint64_t x22;
  uint64_t x23;
  uint64_t x24;
  uint64_t x25;
  uint64_t x26;
  uint64_t x27;
  uint64_t x28;
  uint64_t x29;
  uint64_t x30;
  uint64_t x31;
  uint64_t x32;
  uint64_t x33;
  fiat_p448_uint1 x34;
  uint64_t x35;
  fiat_p448_uint1 x36;
  uint64_t x37;
  uint64_t x38;
  uint64_t x39;
  uint64_t x40;
  fiat_p448_uint1 x41;
  uint64_t x42;
  uint64_t x43;
  fiat_p448_uint1 x44;
  uint64_t x45;
  uint64_t x46;
  x1 = ((arg1[7]) << 2);
  x2 = ((arg1[6]) << 2);
  x3 = ((arg1[5]) << 2);
  x4 = ((arg1[4]) << 2);
  x5 = ((arg1[3]) << 2);
  x6 = ((arg1[2]) << 2);
  x7 = ((arg1[1]) << 2);
  x8 = ((arg1[0]) << 2);
  x9 = (x5 >> 56);
  x10 = (x5 & UINT64_C(0xffffffffffffff));
  x11 = (x9 + x4);
  x12 = (x1 >> 56);
  x13 = (x1 & UINT64_C(0xffffffffffffff));
  x14 = (x11 + x12);
  x15 = (x14 >> 56);
  x16 = (x14 & UINT64_C(0xffffffffffffff));
  x17 = (x8 + x12);
  x18 = (x15 + x3);
  x19 = (x17 >> 56);
  x20 = (x17 & UINT64_C(0xffffffffffffff));
  x21 = (x19 + x7);
  x22 = (x18 >> 56);
  x23 = (x18 & UINT64_C(0xffffffffffffff));
  x24 = (x22 + x2);
  x25 = (x21 >> 56);
  x26 = (x21 & UINT64_C(0xffffffffffffff));
  x27 = (x25 + x6);
  x28 = (x24 >> 56);
  x29 = (x24 & UINT64_C(0xffffffffffffff));
  x30 = (x28 + x13);
  x31 = (x27 >> 56);
  x32 = (x27 & UINT64_C(0xffffffffffffff));
  x33 = (x31 + x10);
  x34 = (fiat_p448_uint1)(x30 >> 56);
  x35 = (x30 & UINT64_C(0xffffffffffffff));
  x36 = (fiat_p448_uint1)(x33 >> 56);
  x37 = (x33 & UINT64_C(0xffffffffffffff));
  x38 = (x16 + (uint64_t)x34);
  x39 = (x20 + (uint64_t)x34);
  x40 = (x36 + x38);
  x41 = (fiat_p448_uint1)(x40 >> 56);
  x42 = (x40 & UINT64_C(0xffffffffffffff));
  x43 = (x41 + x23);
  x44 = (fiat_p448_uint1)(x39 >> 56);
  x45 = (x39 & UINT64_C(0xffffffffffffff));
  x46 = (x44 + x26);
  out1[0] = x45;
  out1[1] = x46;
  out1[2] = x32;
  out1[3] = x37;
  out1[4] = x42;
  out1[5] = x43;
  out1[6] = x29;
  out1[7] = x35;
}

/*
 * The function fiat_p448_carry_scmul_8 multiplies a field element by 8 and reduces the result.
 * Postconditions:
 *   eval out1 mod m = (8 * eval arg1) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000]]
 */
static void fiat_p448_carry_scmul_8(uint64_t out1[8], const uint64_t arg1[8]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  uint64_t x9;
  uint64_t x10;
  uint64_t x11;
  uint64_t x12;
  uint64_t x13;
  uint64_t x14;
  uint64_t x15;
  uint64_t x16;
  uint64_t x17;
  uint64_t x18;
  uint64_t x19;
  uint64_t x20;
  uint64_t x21;
  uint64_t x22;
  uint64_t x23;
  uint64_t x24;
  uint64_t x25;
  uint64_t x26;
  uint64_t x27;
  uint64_t x28;
  uint64_t x29;
  uint64_t x30;
  uint64_t x31;
  uint64_t x32;
  uint64_t x33;
  fiat_p448_uint1 x34;
  uint64_t x35;
  fiat_p448_uint1 x36;
  uint64_t x37;
  uint64_t x38;
  uint64_t x39;
  uint64_t x40;
  fiat_p448_uint1 x41;
  uint64_t x42;
  uint64_t x43;
  fiat_p448_uint1 x44;
  uint64_t x45;
  uint64_t x46;
  x1 = ((arg1[7]) << 3);
  x2 = ((arg1[6]) << 3);
  x3 = ((arg1[5]) << 3);
  x4 = ((arg1[4]) << 3);
  x5 = ((arg1[3]) << 3);
  x6 = ((arg1[2]) << 3);
  x7 = ((arg1[1]) << 3);
  x8 = ((arg1[0]) << 3);
  x9 = (x5 >> 56);
  x10 = (x5 & UINT64_C(0xffffffffffffff));
  x11 = (x9 + x4);
  x12 = (x1 >> 56);
  x13 = (x1 & UINT64_C(0xffffffffffffff));
  x14 = (x11 + x12);
  x15 = (x14 >> 56);
  x16 = (x14 & UINT64_C(0xffffffffffffff));
  x17 = (x8 + x12);
  x18 = (x15 + x3);
  x19 = (x17 >> 56);
  x20 = (x17 & UINT64_C(0xffffffffffffff));
  x21 = (x19 + x7);
  x22 = (x18 >> 56);
  x23 = (x18 & UINT64_C(0xffffffffffffff));
  x24 = (x22 + x2);
  x25 = (x21 >> 56);
  x26 = (x21 & UINT64_C(0xffffffffffffff));
  x27 = (x25 + x6);
  x28 = (x24 >> 56);
  x29 = (x24 & UINT64_C(0xffffffffffffff));
  x30 = (x28 + x13);
  x31 = (x27 >> 56);
  x32 = (x27 & UINT64_C(0xffffffffffffff));
  x33 = (x31 + x10);
  x34 = (fiat_p448_uint1)(x30 >> 56);
  x35 = (x30 & UINT64_C(0xffffffffffffff));
  x36 = (fiat_p448_uint1)(x33 >> 56);
  x37 = (x33 & UINT64_C(0xffffffffffffff));
  x38 = (x16 + (uint64_t)x34);
  x39 = (x20 + (uint64_t)x34);
  x40 = (x36 + x38);
  x41 = (fiat_p448_uint1)(x40 >> 56);
  x42 = (x40 & UINT64_C(0xffffffffffffff));
  x43 = (x41 + x23);
  x44 = (fiat_p448_uint1)(x39 >> 56);
  x45 = (x39 & UINT64_C(0xffffffffffffff));
  x46 = (x44 + x26);
  out1[0] = x45;
  out1[1] = x46;
  out1[2] = x32;
  out1[3] = x37;
  out1[4] = x42;
  out1[5] = x43;
  out1[6] = x29;
  out1[7] = x35;
}

/*
 * The function fiat_p448_carry_scmul_39082 multiplies a field element by 39082 and reduces the result.
 * Postconditions:
 *   eval out1 mod m = (39082 * eval arg1) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000]]
 */
static void fiat_p448_carry_scmul_39082(uint64_t out1[8], const uint64_t arg1[8]) {
  fiat_p448_uint128 x1;
  fiat_p448_uint128 x2;
  fiat_p448_uint128 x3;
  fiat_p448_uint128 x4;
  fiat_p448_uint128 x5;
  fiat_p448_uint128 x6;
  fiat_p448_uint128 x7;
  fiat_p448_uint128 x8;
  uint64_t x9;
  uint64_t x10;
  fiat_p448_uint128 x11;
  uint64_t x12;
  uint64_t x13;
  fiat_p448_uint128 x14;
  uint64_t x15;
  uint64_t x16;
  fiat_p448_uint128 x17;
  fiat_p448_uint128 x18;
  uint64_t x19;
  uint64_t x20;
  fiat_p448_uint128 x21;
  uint64_t x22;
  uint64_t x23;
  fiat_p448_uint128 x24;
  uint64_t x25;
  uint64_t x26;
  fiat_p448_uint128 x27;
  uint64_t x28;
  uint64_t x29;
  uint64_t x30;
  uint64_t x31;
  uint64_t x32;
  uint64_t x33;
  fiat_p448_uint1 x34;
  uint64_t x35;
  fiat_p448_uint1 x36;
  uint64_t x37;
  uint64_t x38;
  uint64_t x39;
  uint64_t x40;
  fiat_p448_uint1 x41;
  uint64_t x42;
  uint64_t x43;
  fiat_p448_uint1 x44;
  uint64_t x45;
  uint64_t x46;
  x1 = ((fiat_p448_uint128)UINT16_C(0x98aa) * (arg1[7]));
  x2 = ((fiat_p448_uint128)UINT16_C(0x98aa) * (arg1[6]));
  x3 = ((fiat_p448_uint128)UINT16_C(0x98aa) * (arg1[5]));
  x4 = ((fiat_p448_uint128)UINT16_C(0x98aa) * (arg1[4]));
  x5 = ((fiat_p448_uint128)UINT16_C(0x98aa) * (arg1[3]));
  x6 = ((fiat_p448_uint128)UINT16_C(0x98aa) * (arg1[2]));
  x7 = ((fiat_p448_uint128)UINT16_C(0x98aa) * (arg1[1]));
  x8 = ((fiat_p448_uint128)UINT16_C(0x98aa) * (arg1[0]));
  x9 = (uint64_t)(x5 >> 56);
  x10 = (uint64_t)(x5 & UINT64_C(0xffffffffffffff));
  x11 = (x9 + x4);
  x12 = (uint64_t)(x1 >> 56);
  x13 = (uint64_t)(x1 & UINT64_C(0xffffffffffffff));
  x14 = (x11 + x12);
  x15 = (uint64_t)(x14 >> 56);
  x16 = (uint64_t)(x14 & UINT64_C(0xffffffffffffff));
  x17 = (x8 + x12);
  x18 = (x15 + x3);
  x19 = (uint64_t)(x17 >> 56);
  x20 = (uint64_t)(x17 & UINT64_C(0xffffffffffffff));
  x21 = (x19 + x7);
  x22 = (uint64_t)(x18 >> 56);
  x23 = (uint64_t)(x18 & UINT64_C(0xffffffffffffff));
  x24 = (x22 + x2);
  x25 = (uint64_t)(x21 >> 56);
  x26 = (uint64_t)(x21 & UINT64_C(0xffffffffffffff));
  x27 = (x25 + x6);
  x28 = (uint64_t)(x24 >> 56);
  x29 = (uint64_t)(x24 & UINT64_C(0xffffffffffffff));
  x30 = (x28 + x13);
  x31 = (uint64_t)(x27 >> 56);
  x32 = (uint64_t)(x27 & UINT64_C(0xffffffffffffff));
  x33 = (x31 + x10);
  x34 = (fiat_p448_uint1)(x30 >> 56);
  x35 = (x30 & UINT64_C(0xffffffffffffff));
  x36 = (fiat_p448_uint1)(x33 >> 56);
  x37 = (x33 & UINT64_C(0xffffffffffffff));
  x38 = (x16 + (uint64_t)x34);
  x39 = (x20 + (uint64_t)x34);
  x40 = (x36 + x38);
  x41 = (fiat_p448_uint1)(x40 >> 56);
  x42 = (x40 & UINT64_C(0xffffffffffffff));
  x43 = (x41 + x23);
  x44 = (fiat_p448_uint1)(x39 >> 56);
  x45 = (x39 & UINT64_C(0xffffffffffffff));
  x46 = (x44 + x26);
  out1[0] = x45;
  out1[1] = x46;
  out1[2] = x32;
  out1[3] = x37;
  out1[4] = x42;
  out1[5] = x43;
  out1[6] = x29;
  out1[7] = x35;
}

/*
 * The function fiat_p448_carry_scmul_39081 multiplies a field element by 39081 and reduces the result.
 * Postconditions:
 *   eval out1 mod m = (39081 * eval arg1) mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000], [0x0 ~> 0x300000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000]]
 */
static void fiat_p448_carry_scmul_39081(uint64_t out1[8], const uint64_t arg1[8]) {
  fiat_p448_uint128 x1;
  fiat_p448_uint128 x2;
  fiat_p448_uint128 x3;
  fiat_p448_uint128 x4;
  fiat_p448_uint128 x5;
  fiat_p448_uint128 x6;
  fiat_p448_uint128 x7;
  fiat_p448_uint128 x8;
  uint64_t x9;
  uint64_t x10;
  fiat_p448_uint128 x11;
  uint64_t x12;
  uint64_t x13;
  fiat_p448_uint128 x14;
  uint64_t x15;
  uint64_t x16;
  fiat_p448_uint128 x17;
  fiat_p448_uint128 x18;
  uint64_t x19;
  uint64_t x20;
  fiat_p448_uint128 x21;
  uint64_t x22;
  uint64_t x23;
  fiat_p448_uint128 x24;
  uint64_t x25;
  uint64_t x26;
  fiat_p448_uint128 x27;
  uint64_t x28;
  uint64_t x29;
  uint64_t x30;
  uint64_t x31;
  uint64_t x32;
  uint64_t x33;
  fiat_p448_uint1 x34;
  uint64_t x35;
  fiat_p448_uint1 x36;
  uint64_t x37;
  uint64_t x38;
  uint64_t x39;
  uint64_t x40;
  fiat_p448_uint1 x41;
  uint64_t x42;
  uint64_t x43;
  fiat_p448_uint1 x44;
  uint64_t x45;
  uint64_t x46;
  x1 = ((fiat_p448_uint128)UINT16_C(0x98a9) * (arg1[7]));
  x2 = ((fiat_p448_uint128)UINT16_C(0x98a9) * (arg1[6]));
  x3 = ((fiat_p448_uint128)UINT16_C(0x98a9) * (arg1[5]));
  x4 = ((fiat_p448_uint128)UINT16_C(0x98a9) * (arg1[4]));
  x5 = ((fiat_p448_uint128)UINT16_C(0x98a9) * (arg1[3]));
  x6 = ((fiat_p448_uint128)UINT16_C(0x98a9) * (arg1[2]));
  x7 = ((fiat_p448_uint128)UINT16_C(0x98a9) * (arg1[1]));
  x8 = ((fiat_p448_uint128)UINT16_C(0x98a9) * (arg1[0]));
  x9 = (uint64_t)(x5 >> 56);
  x10 = (uint64_t)(x5 & UINT64_C(0xffffffffffffff));
  x11 = (x9 + x4);
  x12 = (uint64_t)(x1 >> 56);
  x13 = (uint64_t)(x1 & UINT64_C(0xffffffffffffff));
  x14 = (x11 + x12);
  x15 = (uint64_t)(x14 >> 56);
  x16 = (uint64_t)(x14 & UINT64_C(0xffffffffffffff));
  x17 = (x8 + x12);
  x18 = (x15 + x3);
  x19 = (uint64_t)(x17 >> 56);
  x20 = (uint64_t)(x17 & UINT64_C(0xffffffffffffff));
  x21 = (x19 + x7);
  x22 = (uint64_t)(x18 >> 56);
  x23 = (uint64_t)(x18 & UINT64_C(0xffffffffffffff));
  x24 = (x22 + x2);
  x25 = (uint64_t)(x21 >> 56);
  x26 = (uint64_t)(x21 & UINT64_C(0xffffffffffffff));
  x27 = (x25 + x6);
  x28 = (uint64_t)(x24 >> 56);
  x29 = (uint64_t)(x24 & UINT64_C(0xffffffffffffff));
  x30 = (x28 + x13);
  x31 = (uint64_t)(x27 >> 56);
  x32 = (uint64_t)(x27 & UINT64_C(0xffffffffffffff));
  x33 = (x31 + x10);
  x34 = (fiat_p448_uint1)(x30 >> 56);
  x35 = (x30 & UINT64_C(0xffffffffffffff));
  x36 = (fiat_p448_uint1)(x33 >> 56);
  x37 = (x33 & UINT64_C(0xffffffffffffff));
  x38 = (x16 + (uint64_t)x34);
  x39 = (x20 + (uint64_t)x34);
  x40 = (x36 + x38);
  x41 = (fiat_p448_uint1)(x40 >> 56);
  x42 = (x40 & UINT64_C(0xffffffffffffff));
  x43 = (x41 + x23);
  x44 = (fiat_p448_uint1)(x39 >> 56);
  x45 = (x39 & UINT64_C(0xffffffffffffff));
  x46 = (x44 + x26);
  out1[0] = x45;
  out1[1] = x46;
  out1[2] = x32;
  out1[3] = x37;
  out1[4] = x42;
  out1[5] = x43;
  out1[6] = x29;
  out1[7] = x35;
}

/*
 * The function fiat_p448_selectznz is a multi-limb conditional select.
 * Postconditions:
 *   eval out1 = (if arg1 = 0 then eval arg2 else eval arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
static void fiat_p448_selectznz(uint64_t out1[8], fiat_p448_uint1 arg1, const uint64_t arg2[8], const uint64_t arg3[8]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  fiat_p448_cmovznz_u64(&x1, arg1, (arg2[0]), (arg3[0]));
  fiat_p448_cmovznz_u64(&x2, arg1, (arg2[1]), (arg3[1]));
  fiat_p448_cmovznz_u64(&x3, arg1, (arg2[2]), (arg3[2]));
  fiat_p448_cmovznz_u64(&x4, arg1, (arg2[3]), (arg3[3]));
  fiat_p448_cmovznz_u64(&x5, arg1, (arg2[4]), (arg3[4]));
  fiat_p448_cmovznz_u64(&x6, arg1, (arg2[5]), (arg3[5]));
  fiat_p448_cmovznz_u64(&x7, arg1, (arg2[6]), (arg3[6]));
  fiat_p448_cmovznz_u64(&x8, arg1, (arg2[7]), (arg3[7]));
  out1[0] = x1;
  out1[1] = x2;
  out1[2] = x3;
  out1[3] = x4;
  out1[4] = x5;
  out1[5] = x6;
  out1[6] = x7;
  out1[7] = x8;
}

/*
 * The function fiat_p448_to_bytes serializes a field element to bytes in little-endian order.
 * Postconditions:
 *   out1 = map (λ x, ⌊((eval arg1 mod m) mod 2^(8 * (x + 1))) / 2^(8 * x)⌋) [0..55]
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]
 */
static void fiat_p448_to_bytes(uint8_t out1[56], const uint64_t arg1[8]) {
  uint64_t x1;
  fiat_p448_uint1 x2;
  uint64_t x3;
  fiat_p448_uint1 x4;
  uint64_t x5;
  fiat_p448_uint1 x6;
  uint64_t x7;
  fiat_p448_uint1 x8;
  uint64_t x9;
  fiat_p448_uint1 x10;
  uint64_t x11;
  fiat_p448_uint1 x12;
  uint64_t x13;
  fiat_p448_uint1 x14;
  uint64_t x15;
  fiat_p448_uint1 x16;
  uint64_t x17;
  uint64_t x18;
  fiat_p448_uint1 x19;
  uint64_t x20;
  fiat_p448_uint1 x21;
  uint64_t x22;
  fiat_p448_uint1 x23;
  uint64_t x24;
  fiat_p448_uint1 x25;
  uint64_t x26;
  fiat_p448_uint1 x27;
  uint64_t x28;
  fiat_p448_uint1 x29;
  uint64_t x30;
  fiat_p448_uint1 x31;
  uint64_t x32;
  fiat_p448_uint1 x33;
  uint8_t x34;
  uint64_t x35;
  uint8_t x36;
  uint64_t x37;
  uint8_t x38;
  uint64_t x39;
  uint8_t x40;
  uint64_t x41;
  uint8_t x42;
  uint64_t x43;
  uint8_t x44;
  uint8_t x45;
  uint8_t x46;
  uint64_t x47;
  uint8_t x48;
  uint64_t x49;
  uint8_t x50;
  uint64_t x51;
  uint8_t x52;
  uint64_t x53;
  uint8_t x54;
  uint64_t x55;
  uint8_t x56;
  uint8_t x57;
  uint8_t x58;
  uint64_t x59;
  uint8_t x60;
  uint64_t x61;
  uint8_t x62;
  uint64_t x63;
  uint8_t x64;
  uint64_t x65;
  uint8_t x66;
  uint64_t x67;
  uint8_t x68;
  uint8_t x69;
  uint8_t x70;
  uint64_t x71;
  uint8_t x72;
  uint64_t x73;
  uint8_t x74;
  uint64_t x75;
  uint8_t x76;
  uint64_t x77;
  uint8_t x78;
  uint64_t x79;
  uint8_t x80;
  uint8_t x81;
  uint8_t x82;
  uint64_t x83;
  uint8_t x84;
  uint64_t x85;
  uint8_t x86;
  uint64_t x87;
  uint8_t x88;
  uint64_t x89;
  uint8_t x90;
  uint64_t x91;
  uint8_t x92;
  uint8_t x93;
  uint8_t x94;
  uint64_t x95;
  uint8_t x96;
  uint64_t x97;
  uint8_t x98;
  uint64_t x99;
  uint8_t x100;
  uint64_t x101;
  uint8_t x102;
  uint64_t x103;
  uint8_t x104;
  uint8_t x105;
  uint8_t x106;
  uint64_t x107;
  uint8_t x108;
  uint64_t x109;
  uint8_t x110;
  uint64_t x111;
  uint8_t x112;
  uint64_t x113;
  uint8_t x114;
  uint64_t x115;
  uint8_t x116;
  uint8_t x117;
  uint8_t x118;
  uint64_t x119;
  uint8_t x120;
  uint64_t x121;
  uint8_t x122;
  uint64_t x123;
  uint8_t x124;
  uint64_t x125;
  uint8_t x126;
  uint64_t x127;
  uint8_t x128;
  uint8_t x129;
  fiat_p448_subborrowx_u56(&x1, &x2, 0x0, (arg1[0]), UINT64_C(0xffffffffffffff));
  fiat_p448_subborrowx_u56(&x3, &x4, x2, (arg1[1]), UINT64_C(0xffffffffffffff));
  fiat_p448_subborrowx_u56(&x5, &x6, x4, (arg1[2]), UINT64_C(0xffffffffffffff));
  fiat_p448_subborrowx_u56(&x7, &x8, x6, (arg1[3]), UINT64_C(0xffffffffffffff));
  fiat_p448_subborrowx_u56(&x9, &x10, x8, (arg1[4]), UINT64_C(0xfffffffffffffe));
  fiat_p448_subborrowx_u56(&x11, &x12, x10, (arg1[5]), UINT64_C(0xffffffffffffff));
  fiat_p448_subborrowx_u56(&x13, &x14, x12, (arg1[6]), UINT64_C(0xffffffffffffff));
  fiat_p448_subborrowx_u56(&x15, &x16, x14, (arg1[7]), UINT64_C(0xffffffffffffff));
  fiat_p448_cmovznz_u64(&x17, x16, 0x0, UINT64_C(0xffffffffffffffff));
  fiat_p448_addcarryx_u56(&x18, &x19, 0x0, x1, (x17 & UINT64_C(0xffffffffffffff)));
  fiat_p448_addcarryx_u56(&x20, &x21, x19, x3, (x17 & UINT64_C(0xffffffffffffff)));
  fiat_p448_addcarryx_u56(&x22, &x23, x21, x5, (x17 & UINT64_C(0xffffffffffffff)));
  fiat_p448_addcarryx_u56(&x24, &x25, x23, x7, (x17 & UINT64_C(0xffffffffffffff)));
  fiat_p448_addcarryx_u56(&x26, &x27, x25, x9, (x17 & UINT64_C(0xfffffffffffffe)));
  fiat_p448_addcarryx_u56(&x28, &x29, x27, x11, (x17 & UINT64_C(0xffffffffffffff)));
  fiat_p448_addcarryx_u56(&x30, &x31, x29, x13, (x17 & UINT64_C(0xffffffffffffff)));
  fiat_p448_addcarryx_u56(&x32, &x33, x31, x15, (x17 & UINT64_C(0xffffffffffffff)));
  x34 = (uint8_t)(x18 & UINT8_C(0xff));
  x35 = (x18 >> 8);
  x36 = (uint8_t)(x35 & UINT8_C(0xff));
  x37 = (x35 >> 8);
  x38 = (uint8_t)(x37 & UINT8_C(0xff));
  x39 = (x37 >> 8);
  x40 = (uint8_t)(x39 & UINT8_C(0xff));
  x41 = (x39 >> 8);
  x42 = (uint8_t)(x41 & UINT8_C(0xff));
  x43 = (x41 >> 8);
  x44 = (uint8_t)(x43 & UINT8_C(0xff));
  x45 = (uint8_t)(x43 >> 8);
  x46 = (uint8_t)(x20 & UINT8_C(0xff));
  x47 = (x20 >> 8);
  x48 = (uint8_t)(x47 & UINT8_C(0xff));
  x49 = (x47 >> 8);
  x50 = (uint8_t)(x49 & UINT8_C(0xff));
  x51 = (x49 >> 8);
  x52 = (uint8_t)(x51 & UINT8_C(0xff));
  x53 = (x51 >> 8);
  x54 = (uint8_t)(x53 & UINT8_C(0xff));
  x55 = (x53 >> 8);
  x56 = (uint8_t)(x55 & UINT8_C(0xff));
  x57 = (uint8_t)(x55 >> 8);
  x58 = (uint8_t)(x22 & UINT8_C(0xff));
  x59 = (x22 >> 8);
  x60 = (uint8_t)(x59 & UINT8_C(0xff));
  x61 = (x59 >> 8);
  x62 = (uint8_t)(x61 & UINT8_C(0xff));
  x63 = (x61 >> 8);
  x64 = (uint8_t)(x63 & UINT8_C(0xff));
  x65 = (x63 >> 8);
  x66 = (uint8_t)(x65 & UINT8_C(0xff));
  x67 = (x65 >> 8);
  x68 = (uint8_t)(x67 & UINT8_C(0xff));
  x69 = (uint8_t)(x67 >> 8);
  x70 = (uint8_t)(x24 & UINT8_C(0xff));
  x71 = (x24 >> 8);
  x72 = (uint8_t)(x71 & UINT8_C(0xff));
  x73 = (x71 >> 8);
  x74 = (uint8_t)(x73 & UINT8_C(0xff));
  x75 = (x73 >> 8);
  x76 = (uint8_t)(x75 & UINT8_C(0xff));
  x77 = (x75 >> 8);
  x78 = (uint8_t)(x77 & UINT8_C(0xff));
  x79 = (x77 >> 8);
  x80 = (uint8_t)(x79 & UINT8_C(0xff));
  x81 = (uint8_t)(x79 >> 8);
  x82 = (uint8_t)(x26 & UINT8_C(0xff));
  x83 = (x26 >> 8);
  x84 = (uint8_t)(x83 & UINT8_C(0xff));
  x85 = (x83 >> 8);
  x86 = (uint8_t)(x85 & UINT8_C(0xff));
  x87 = (x85 >> 8);
  x88 = (uint8_t)(x87 & UINT8_C(0xff));
  x89 = (x87 >> 8);
  x90 = (uint8_t)(x89 & UINT8_C(0xff));
  x91 = (x89 >> 8);
  x92 = (uint8_t)(x91 & UINT8_C(0xff));
  x93 = (uint8_t)(x91 >> 8);
  x94 = (uint8_t)(x28 & UINT8_C(0xff));
  x95 = (x28 >> 8);
  x96 = (uint8_t)(x95 & UINT8_C(0xff));
  x97 = (x95 >> 8);
  x98 = (uint8_t)(x97 & UINT8_C(0xff));
  x99 = (x97 >> 8);
  x100 = (uint8_t)(x99 & UINT8_C(0xff));
  x101 = (x99 >> 8);
  x102 = (uint8_t)(x101 & UINT8_C(0xff));
  x103 = (x101 >> 8);
  x104 = (uint8_t)(x103 & UINT8_C(0xff));
  x105 = (uint8_t)(x103 >> 8);
  x106 = (uint8_t)(x30 & UINT8_C(0xff));
  x107 = (x30 >> 8);
  x108 = (uint8_t)(x107 & UINT8_C(0xff));
  x109 = (x107 >> 8);
  x110 = (uint8_t)(x109 & UINT8_C(0xff));
  x111 = (x109 >> 8);
  x112 = (uint8_t)(x111 & UINT8_C(0xff));
  x113 = (x111 >> 8);
  x114 = (uint8_t)(x113 & UINT8_C(0xff));
  x115 = (x113 >> 8);
  x116 = (uint8_t)(x115 & UINT8_C(0xff));
  x117 = (uint8_t)(x115 >> 8);
  x118 = (uint8_t)(x32 & UINT8_C(0xff));
  x119 = (x32 >> 8);
  x120 = (uint8_t)(x119 & UINT8_C(0xff));
  x121 = (x119 >> 8);
  x122 = (uint8_t)(x121 & UINT8_C(0xff));
  x123 = (x121 >> 8);
  x124 = (uint8_t)(x123 & UINT8_C(0xff));
  x125 = (x123 >> 8);
  x126 = (uint8_t)(x125 & UINT8_C(0xff));
  x127 = (x125 >> 8);
  x128 = (uint8_t)(x127 & UINT8_C(0xff));
  x129 = (uint8_t)(x127 >> 8);
  out1[0] = x34;
  out1[1] = x36;
  out1[2] = x38;
  out1[3] = x40;
  out1[4] = x42;
  out1[5] = x44;
  out1[6] = x45;
  out1[7] = x46;
  out1[8] = x48;
  out1[9] = x50;
  out1[10] = x52;
  out1[11] = x54;
  out1[12] = x56;
  out1[13] = x57;
  out1[14] = x58;
  out1[15] = x60;
  out1[16] = x62;
  out1[17] = x64;
  out1[18] = x66;
  out1[19] = x68;
  out1[20] = x69;
  out1[21] = x70;
  out1[22] = x72;
  out1[23] = x74;
  out1[24] = x76;
  out1[25] = x78;
  out1[26] = x80;
  out1[27] = x81;
  out1[28] = x82;
  out1[29] = x84;
  out1[30] = x86;
  out1[31] = x88;
  out1[32] = x90;
  out1[33] = x92;
  out1[34] = x93;
  out1[35] = x94;
  out1[36] = x96;
  out1[37] = x98;
  out1[38] = x100;
  out1[39] = x102;
  out1[40] = x104;
  out1[41] = x105;
  out1[42] = x106;
  out1[43] = x108;
  out1[44] = x110;
  out1[45] = x112;
  out1[46] = x114;
  out1[47] = x116;
  out1[48] = x117;
  out1[49] = x118;
  out1[50] = x120;
  out1[51] = x122;
  out1[52] = x124;
  out1[53] = x126;
  out1[54] = x128;
  out1[55] = x129;
}

/*
 * The function fiat_p448_from_bytes deserializes a field element from bytes in little-endian order.
 * Postconditions:
 *   eval out1 mod m = bytes_eval arg1 mod m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000], [0x0 ~> 0x100000000000000]]
 */
static void fiat_p448_from_bytes(uint64_t out1[8], const uint8_t arg1[56]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint8_t x7;
  uint64_t x8;
  uint64_t x9;
  uint64_t x10;
  uint64_t x11;
  uint64_t x12;
  uint64_t x13;
  uint8_t x14;
  uint64_t x15;
  uint64_t x16;
  uint64_t x17;
  uint64_t x18;
  uint64_t x19;
  uint64_t x20;
  uint8_t x21;
  uint64_t x22;
  uint64_t x23;
  uint64_t x24;
  uint64_t x25;
  uint64_t x26;
  uint64_t x27;
  uint8_t x28;
  uint64_t x29;
  uint64_t x30;
  uint64_t x31;
  uint64_t x32;
  uint64_t x33;
  uint64_t x34;
  uint8_t x35;
  uint64_t x36;
  uint64_t x37;
  uint64_t x38;
  uint64_t x39;
  uint64_t x40;
  uint64_t x41;
  uint8_t x42;
  uint64_t x43;
  uint64_t x44;
  uint64_t x45;
  uint64_t x46;
  uint64_t x47;
  uint64_t x48;
  uint8_t x49;
  uint64_t x50;
  uint64_t x51;
  uint64_t x52;
  uint64_t x53;
  uint64_t x54;
  uint64_t x55;
  uint8_t x56;
  uint64_t x57;
  uint64_t x58;
  uint64_t x59;
  uint64_t x60;
  uint64_t x61;
  uint64_t x62;
  uint64_t x63;
  uint64_t x64;
  uint64_t x65;
  uint64_t x66;
  uint64_t x67;
  uint64_t x68;
  uint64_t x69;
  uint64_t x70;
  uint64_t x71;
  uint64_t x72;
  uint64_t x73;
  uint64_t x74;
  uint64_t x75;
  uint64_t x76;
  uint64_t x77;
  uint64_t x78;
  uint64_t x79;
  uint64_t x80;
  uint64_t x81;
  uint64_t x82;
  uint64_t x83;
  uint64_t x84;
  uint64_t x85;
  uint64_t x86;
  uint64_t x87;
  uint64_t x88;
  uint64_t x89;
  uint64_t x90;
  uint64_t x91;
  uint64_t x92;
  uint64_t x93;
  uint64_t x94;
  uint64_t x95;
  uint64_t x96;
  uint64_t x97;
  uint64_t x98;
  uint64_t x99;
  uint64_t x100;
  uint64_t x101;
  uint64_t x102;
  uint64_t x103;
  uint64_t x104;
  x1 = ((uint64_t)(arg1[55]) << 48);
  x2 = ((uint64_t)(arg1[54]) << 40);
  x3 = ((uint64_t)(arg1[53]) << 32);
  x4 = ((uint64_t)(arg1[52]) << 24);
  x5 = ((uint64_t)(arg1[51]) << 16);
  x6 = ((uint64_t)(arg1[50]) << 8);
  x7 = (arg1[49]);
  x8 = ((uint64_t)(arg1[48]) << 48);
  x9 = ((uint64_t)(arg1[47]) << 40);
  x10 = ((uint64_t)(arg1[46]) << 32);
  x11 = ((uint64_t)(arg1[45]) << 24);
  x12 = ((uint64_t)(arg1[44]) << 16);
  x13 = ((uint64_t)(arg1[43]) << 8);
  x14 = (arg1[42]);
  x15 = ((uint64_t)(arg1[41]) << 48);
  x16 = ((uint64_t)(arg1[40]) << 40);
  x17 = ((uint64_t)(arg1[39]) << 32);
  x18 = ((uint64_t)(arg1[38]) << 24);
  x19 = ((uint64_t)(arg1[37]) << 16);
  x20 = ((uint64_t)(arg1[36]) << 8);
  x21 = (arg1[35]);
  x22 = ((uint64_t)(arg1[34]) << 48);
  x23 = ((uint64_t)(arg1[33]) << 40);
  x24 = ((uint64_t)(arg1[32]) << 32);
  x25 = ((uint64_t)(arg1[31]) << 24);
  x26 = ((uint64_t)(arg1[30]) << 16);
  x27 = ((uint64_t)(arg1[29]) << 8);
  x28 = (arg1[28]);
  x29 = ((uint64_t)(arg1[27]) << 48);
  x30 = ((uint64_t)(arg1[26]) << 40);
  x31 = ((uint64_t)(arg1[25]) << 32);
  x32 = ((uint64_t)(arg1[24]) << 24);
  x33 = ((uint64_t)(arg1[23]) << 16);
  x34 = ((uint64_t)(arg1[22]) << 8);
  x35 = (arg1[21]);
  x36 = ((uint64_t)(arg1[20]) << 48);
  x37 = ((uint64_t)(arg1[19]) << 40);
  x38 = ((uint64_t)(arg1[18]) << 32);
  x39 = ((uint64_t)(arg1[17]) << 24);
  x40 = ((uint64_t)(arg1[16]) << 16);
  x41 = ((uint64_t)(arg1[15]) << 8);
  x42 = (arg1[14]);
  x43 = ((uint64_t)(arg1[13]) << 48);
  x44 = ((uint64_t)(arg1[12]) << 40);
  x45 = ((uint64_t)(arg1[11]) << 32);
  x46 = ((uint64_t)(arg1[10]) << 24);
  x47 = ((uint64_t)(arg1[9]) << 16);
  x48 = ((uint64_t)(arg1[8]) << 8);
  x49 = (arg1[7]);
  x50 = ((uint64_t)(arg1[6]) << 48);
  x51 = ((uint64_t)(arg1[5]) << 40);
  x52 = ((uint64_t)(arg1[4]) << 32);
  x53 = ((uint64_t)(arg1[3]) << 24);
  x54 = ((uint64_t)(arg1[2]) << 16);
  x55 = ((uint64_t)(arg1[1]) << 8);
  x56 = (arg1[0]);
  x57 = (x55 + (uint64_t)x56);
  x58 = (x54 + x57);
  x59 = (x53 + x58);
  x60 = (x52 + x59);
  x61 = (x51 + x60);
  x62 = (x50 + x61);
  x63 = (x48 + (uint64_t)x49);
  x64 = (x47 + x63);
  x65 = (x46 + x64);
  x66 = (x45 + x65);
  x67 = (x44 + x66);
  x68 = (x43 + x67);
  x69 = (x41 + (uint64_t)x42);
  x70 = (x40 + x69);
  x71 = (x39 + x70);
  x72 = (x38 + x71);
  x73 = (x37 + x72);
  x74 = (x36 + x73);
  x75 = (x34 + (uint64_t)x35);
  x76 = (x33 + x75);
  x77 = (x32 + x76);
  x78 = (x31 + x77);
  x79 = (x30 + x78);
  x80 = (x29 + x79);
  x81 = (x27 + (uint64_t)x28);
  x82 = (x26 + x81);
  x83 = (x25 + x82);
  x84 = (x24 + x83);
  x85 = (x23 + x84);
  x86 = (x22 + x85);
  x87 = (x20 + (uint64_t)x21);
  x88 = (x19 + x87);
  x89 = (x18 + x88);
  x90 = (x17 + x89);
  x91 = (x16 + x90);
  x92 = (x15 + x91);
  x93 = (x13 + (uint64_t)x14);
  x94 = (x12 + x93);
  x95 = (x11 + x94);
  x96 = (x10 + x95);
  x97 = (x9 + x96);
  x98 = (x8 + x97);
  x99 = (x6 + (uint64_t)x7);
  x100 = (x5 + x99);
  x101 = (x4 + x100);
  x102 = (x3 + x101);
  x103 = (x2 + x102);
  x104 = (x1 + x103);
  out1[0] = x62;
  out1[1] = x68;
  out1[2] = x74;
  out1[3] = x80;
  out1[4] = x86;
  out1[5] = x92;
  out1[6] = x98;
  out1[7] = x104;
}
